# -*- coding: UTF-8 -*-
from Screen import Screen
from Components.Button import Button
from Components.ActionMap import HelpableActionMap, ActionMap, NumberActionMap
from Components.MenuList import MenuList
from Components.MovieList import MovieList, resetMoviePlayState, AUDIO_EXTENSIONS, DVD_EXTENSIONS, IMAGE_EXTENSIONS
from Components.DiskInfo import DiskInfo
from Components.Pixmap import Pixmap, MultiPixmap
from Components.Label import Label
#
from Components.Language import language
#
from Components.ScrollLabel import ScrollLabel
from Components.PluginComponent import plugins
from Components.config import configfile, config, ConfigSubsection, ConfigText, ConfigInteger, ConfigLocations, ConfigSet, ConfigYesNo, ConfigSelection, getConfigListEntry
from Components.ConfigList import ConfigListScreen
from Components.ServiceEventTracker import ServiceEventTracker, InfoBarBase
from Components.Sources.ServiceEvent import ServiceEvent
from Components.Sources.StaticText import StaticText
import Components.Harddisk
from Components.UsageConfig import preferredTimerPath
from Plugins.Plugin import PluginDescriptor
from Screens.MessageBox import MessageBox
from Screens.ChoiceBox import ChoiceBox
from Screens.LocationBox import MovieLocationBox
from Screens.HelpMenu import HelpableScreen
import Screens.InfoBar
#
from os import environ as os_environ
import gettext, random
#
from Tools import NumericalTextInput
from Tools.Directories import resolveFilename, SCOPE_HDD, fileExists, SCOPE_PLUGINS
from Tools.BoundFunction import boundFunction
import Tools.Trashcan
import NavigationInstance
from enigma import eConsoleAppContainer
import RecordTimer
from enigma import eServiceReference, eServiceCenter, eTimer, eSize, iPlayableService, iServiceInformation, getPrevAsciiCode, eRCInput, loadPic, ePicLoad, ePixmap
import os
import time
import cPickle as pickle
PLUGIN_PATH = '/usr/lib/enigma2/python/Plugins/Extensions/TMBD/fonts'
from enigma import addFont
try:
    addFont('%s/Army_Regular_L.ttf' % PLUGIN_PATH, 'Regular', 95, 1)
    addFont('%s/Go.ttf' % PLUGIN_PATH, 'Go', 100, 1)
    addFont('%s/Scout1.ttf' % PLUGIN_PATH, 'Scout1', 95, 1)
    addFont('%s/Scout.ttf' % PLUGIN_PATH, 'Scout', 95, 1)    
except Exception as ex:
    print ex
config.movielist = ConfigSubsection()
config.movielist.moviesort = ConfigInteger(default=MovieList.SORT_RECORDED)
config.movielist.listtype = ConfigInteger(default=MovieList.LISTTYPE_ORIGINAL2)
config.movielist.description = ConfigInteger(default=MovieList.SHOW_DESCRIPTION)
config.movielist.last_videodir = ConfigText(default=resolveFilename(SCOPE_HDD))
config.movielist.last_timer_videodir = ConfigText(default=resolveFilename(SCOPE_HDD))
config.movielist.videodirs = ConfigLocations(default=[resolveFilename(SCOPE_HDD)])
config.movielist.last_selected_tags = ConfigSet([], default=[])
config.movielist.play_audio_internal = ConfigYesNo(default=True)
config.movielist.settings_per_directory = ConfigYesNo(default=True)
config.movielist.originalname = ConfigYesNo(default=False)
config.movielist.play = ConfigYesNo(default=True)
config.movielist.MovieSelectionfonts = ConfigSelection(default = "0", choices = [
                        ("0", _("Default")), ("1", _("Valis_enigma")), ("2", _("Cursive"))])
config.movielist.MovieSelectionPreviemskins = ConfigSelection(default = "0", choices = [
                        ("0", _("Default")), ("1", _("С постером в фоне"))])
config.movielist.EventViewMovieSelectionskins = ConfigSelection(default = "0", choices = [
                        ("0", _("Default")), ("1", _("С небольшим постером в фоне")), ("2", _("С большим постером в фоне")), ("3", _("Прозрачный")), ("4", _("Концерт"))])
config.movielist.folder = ConfigSelection(default = "0", choices = [
       ("0", _("Возврат в папку  + back.jpg")), ("1", _("back.jpg+описание")), ("2", _("Постер+описание"))])
config.movielist.profilcolor = ConfigSelection(default = "None", choices = [
                        ("None", _("Никакой")), ("2237106", _("Синий")), ("13823", _("Синий2")), ("16715021", _("Красный")), ("8388608", _("Темно-красный")), ("16763955", _("Желтый")), ("39424", _("Зеленый"))])
config.movielist.root = ConfigSelection(default='/media', choices=['/',
 '/media',
 '/media/hdd',
 '/media/hdd/movie'])
config.movielist.hide_extensions = ConfigYesNo(default=False)
userDefinedButtons = None
last_selected_dest = []
preferredTagEditor = None
l_moviesort = [(str(MovieList.SORT_RECORDED), _('по дате'), '03/02/01'),
 (str(MovieList.SORT_ALPHANUMERIC), _('по алфвиту'), 'A-Z'),
 (str(MovieList.SORT_ALPHANUMERIC_FLAT), _('прямой по алфвиту'), 'A-Z Flat'),
 (str(MovieList.SHUFFLE), _('перетасовать'), '?'),
 (str(MovieList.SORT_RECORDED_REVERSE), _('обратный по дате'), '01/02/03'),
 (str(MovieList.SORT_ALPHANUMERIC_REVERSE), _('обратный алфвит'), 'Z-A'),
 (str(MovieList.SORT_ALPHANUMERIC_FLAT_REVERSE), _('flat alphabetic reverse'), 'Z-A Flat')]
l_listtype = [(str(MovieList.LISTTYPE_ORIGINAL), _('список по умолчанию')),
 (str(MovieList.LISTTYPE_COMPACT_DESCRIPTION), _('компактный  список описанием')),
 (str(MovieList.LISTTYPE_COMPACT), _('компактный список')),
 (str(MovieList.LISTTYPE_MINIMAL), _('список в одну строку')),
 (str(MovieList.LISTTYPE_ORIGINAL2), _('новый список с постерами')),
 (str(MovieList.LISTTYPE_MINIMAL2), _('новый список в одну строку')),
 (str(MovieList.LISTTYPE_MINIMAL_PROGRES), _('новый список в одну строку с прогрессами'))]
dircontrol = False

def localeInit():
	lang = language.getLanguage()[:2] # getLanguage returns e.g. "fi_FI" for "language_country"
	os_environ["LANGUAGE"] = lang # Enigma doesn't set this (or LC_ALL, LC_MESSAGES, LANG). gettext needs it!
	gettext.bindtextdomain("MovieSelection", resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/locale"))

def _(txt):
	t = gettext.dgettext("MovieSelection", txt)
	if t == txt:
		#print("[TMBD] fallback to default translation for", txt)
		t = gettext.gettext(txt)
	return t

localeInit()
language.addCallback(localeInit)

def defaultMoviePath():
    global config
    result = config.usage.default_path.value
    if not os.path.isdir(result):
        from Tools import Directories
        return Directories.defaultRecordingLocation()
    return result


def setPreferredTagEditor(te):
    global preferredTagEditor
    if preferredTagEditor is None:
        preferredTagEditor = te
        print 'Preferred tag editor changed to', preferredTagEditor
    else:
        print 'Preferred tag editor already set to', preferredTagEditor, 'ignoring', te
    return


def getPreferredTagEditor():
    return preferredTagEditor


def isTrashFolder(ref):
    if not config.usage.movielist_trashcan.value or not ref.flags & eServiceReference.mustDescent:
        return False
    path = os.path.realpath(ref.getPath())
    return path.endswith('.Trash') and path.startswith(Tools.Trashcan.getTrashFolder(path))


def isInTrashFolder(ref):
    if not config.usage.movielist_trashcan.value or not ref.flags & eServiceReference.mustDescent:
        return False
    path = os.path.realpath(ref.getPath())
    return path.startswith(Tools.Trashcan.getTrashFolder(path))


def isSimpleFile(item):
    if not item:
        return False
    if not item[0] or not item[1]:
        return False
    return item[0].flags & eServiceReference.mustDescent == 0


def isFolder(item):
    if not item:
        return False
    if not item[0] or not item[1]:
        return False
    return item[0].flags & eServiceReference.mustDescent != 0


def canMove(item):
    if not item:
        return False
    if not item[0] or not item[1]:
        return False
    if item[0].flags & eServiceReference.mustDescent:
        return not isTrashFolder(item[0])
    return True


canDelete = canMove

def canCopy(item):
    if not item:
        return False
    if not item[0] or not item[1]:
        return False
    if item[0].flags & eServiceReference.mustDescent:
        return False
    return True


def createMoveList(serviceref, dest):
    src = os.path.normpath(serviceref.getPath())
    srcPath, srcName = os.path.split(src)
    if os.path.normpath(srcPath) == dest:
        raise Exception, 'Refusing to move to the same directory'
    moveList = [(src, os.path.join(dest, srcName))]
    if not serviceref.flags & eServiceReference.mustDescent:
        srcBase = os.path.splitext(src)[0]
        baseName = os.path.split(srcBase)[1]
        eitName = srcBase + '.eit'
        if os.path.exists(eitName):
            moveList.append((eitName, os.path.join(dest, baseName + '.eit')))
        baseName = os.path.split(src)[1]
        for ext in ('.ap', '.cuts', '.meta', '.sc'):
            candidate = src + ext
            if os.path.exists(candidate):
                moveList.append((candidate, os.path.join(dest, baseName + ext)))

    return moveList


def moveServiceFiles(serviceref, dest, name = None, allowCopy = True):
    moveList = createMoveList(serviceref, dest)
    movedList = []
    try:
        try:
            for item in moveList:
                os.rename(item[0], item[1])
                movedList.append(item)

        except OSError as e:
            if e.errno == 18 and allowCopy:
                print '[MovieSelection] cannot rename across devices, trying slow move'
                import CopyFiles
                moveList.reverse()
                if name is None:
                    name = os.path.split(moveList[-1][0])[1]
                CopyFiles.moveFiles(moveList, name)
                print '[MovieSelection] Moving in background...'
            else:
                raise

    except Exception as e:
        print '[MovieSelection] Failed move:', e
        for item in movedList:
            try:
                os.rename(item[1], item[0])
            except:
                print '[MovieSelection] Failed to undo move:', item

        raise

    return


def copyServiceFiles(serviceref, dest, name = None):
    moveList = createMoveList(serviceref, dest)
    movedList = []
    try:
        for item in moveList:
            os.link(item[0], item[1])
            movedList.append(item)

        return
    except Exception as e:
        print '[MovieSelection] Failed copy using link:', e
        for item in movedList:
            try:
                os.unlink(item[1])
            except:
                print '[MovieSelection] Failed to undo copy:', item

    import CopyFiles
    moveList.reverse()
    if name is None:
        name = os.path.split(moveList[-1][0])[1]
    CopyFiles.copyFiles(moveList, name)
    print '[MovieSelection] Copying in background...'
    return


class MovieBrowserConfiguration(ConfigListScreen, Screen):
    skin= """
            <screen position="center,center" size="1000,400" title="Movie Browser Configuration" >
            <ePixmap name="red"    position="0,0"   zPosition="2" size="140,40" pixmap="skin_default/buttons/red.png" transparent="1" alphatest="on" />
            <ePixmap name="green"  position="140,0" zPosition="2" size="140,40" pixmap="skin_default/buttons/green.png" transparent="1" alphatest="on" />
            <widget name="key_red" position="0,0" size="140,40" valign="center" halign="center" zPosition="4"  foregroundColor="white" font="Regular;20" transparent="1" shadowColor="background" shadowOffset="-2,-2" />
            <widget name="key_green" position="140,0" size="140,40" valign="center" halign="center" zPosition="4"  foregroundColor="white" font="Regular;20" transparent="1" shadowColor="background" shadowOffset="-2,-2" />
            <widget name="config" position="10,40" size="980,340" scrollbarMode="showOnDemand" />
            <ePixmap alphatest="on" pixmap="skin_default/icons/clock.png" position="880,383" size="14,14" zPosition="3"/>
            <widget font="Regular;18" halign="left" position="905,380" render="Label" size="55,20" source="global.CurrentTime" transparent="1" valign="center" zPosition="3">
            <convert type="ClockToText">Default</convert>
            </widget>
            </screen>"""

    def __init__(self, session, args = 0):
        global userDefinedButtons
        self.session = session
        self.setup_title = _('Movie list configuration')
        Screen.__init__(self, session)
        cfg = ConfigSubsection()
        self.cfg = cfg
        cfg.moviesort = ConfigSelection(default=str(config.movielist.moviesort.value), choices=l_moviesort)
        cfg.listtype = ConfigSelection(default=str(config.movielist.listtype.value), choices=l_listtype)
        cfg.description = ConfigYesNo(default=config.movielist.description.value != MovieList.HIDE_DESCRIPTION)
        configList = [getConfigListEntry(_('Sort'), cfg.moviesort),
         getConfigListEntry(_('Show extended description'), cfg.description),
         getConfigListEntry(_('Type'), cfg.listtype),
         getConfigListEntry(_('Use individual settings for each directory'), config.movielist.settings_per_directory),
         getConfigListEntry(_('Behavior when a movie reaches the end'), config.usage.on_movie_eof),
         getConfigListEntry(_('Load length of movies in movie list'), config.usage.load_length_of_movies_in_moviellist),
         getConfigListEntry(_('Show status icons in movie list'), config.usage.show_icons_in_movielist),
         getConfigListEntry(_('Font selection'), config.movielist.MovieSelectionfonts),             
         getConfigListEntry(_('Show for the folder type ..'), config.movielist.folder),                         
         getConfigListEntry(_('Play with the show description'), config.movielist.play),
         getConfigListEntry(_('Show original name'), config.movielist.originalname),
         getConfigListEntry(_('Color for names in list style with poster'), config.movielist.profilcolor),
         getConfigListEntry(_('Show poster in EventView'), config.movielist.EventViewMovieSelectionskins ),                     
         getConfigListEntry(_('Show poster in MovieSelectionPreviem'), config.movielist.MovieSelectionPreviemskins ),         
         getConfigListEntry(_('Show icon for new/unseen items'), config.usage.movielist_unseen),
         getConfigListEntry(_('Play audio in background'), config.movielist.play_audio_internal),
         getConfigListEntry(_('Root directory'), config.movielist.root),
         getConfigListEntry(_('Hide known extensions'), config.movielist.hide_extensions)]
        for btn in ('red', 'green', 'yellow', 'blue', 'TV', 'Radio', 'Text'):
            configList.append(getConfigListEntry(_(btn), userDefinedButtons[btn]))

        ConfigListScreen.__init__(self, configList, session=session, on_change=self.changedEntry)
        self['key_red'] = Button(_('Cancel'))
        self['key_green'] = Button(_('Ok'))
        self['key_yellow'] = Button('')
        self['key_blue'] = Button('')
        self['statusbar'] = Label()
        self['status'] = Label()
        self['setupActions'] = ActionMap(['SetupActions', 'ColorActions'], {'red': self.cancel,
         'green': self.save,
         'save': self.save,
         'cancel': self.cancel,
         'ok': self.save}, -2)
        self.onChangedEntry = []

    def changedEntry(self):
        for x in self.onChangedEntry:
            x()

    def getCurrentEntry(self):
        return self['config'].getCurrent()[0]

    def getCurrentValue(self):
        return str(self['config'].getCurrent()[1].getText())

    def createSummary(self):
        from Screens.Setup import SetupSummary
        return SetupSummary

    def save(self):
        self.saveAll()
        cfg = self.cfg
        config.movielist.moviesort.value = int(cfg.moviesort.value)
        config.movielist.listtype.value = int(cfg.listtype.value)
        config.movielist.listtype.save()
        if cfg.description.value:
            config.movielist.description.value = MovieList.SHOW_DESCRIPTION
        else:
            config.movielist.description.value = MovieList.HIDE_DESCRIPTION
        if not config.movielist.settings_per_directory.value:
            config.movielist.moviesort.save()
            config.movielist.listtype.save()
            config.movielist.description.save()
            config.usage.on_movie_eof.save()
        configfile.save()    
        self.close(True)

    def cancel(self):
        for x in self['config'].list:
            x[1].cancel()

        self.close(False)


class MovieContextMenuSummary(Screen):

    def __init__(self, session, parent):
        Screen.__init__(self, session, parent=parent)
        self['selected'] = StaticText('')
        self.onShow.append(self.__onShow)
        self.onHide.append(self.__onHide)

    def __onShow(self):
        self.parent['menu'].onSelectionChanged.append(self.selectionChanged)
        self.selectionChanged()

    def __onHide(self):
        self.parent['menu'].onSelectionChanged.remove(self.selectionChanged)

    def selectionChanged(self):
        item = self.parent['menu'].getCurrent()
        self['selected'].text = item[0]


class MovieContextMenu(Screen):

    def __init__(self, session, csel, service):
        Screen.__init__(self, session)
        self['actions'] = ActionMap(['OkCancelActions', 'ColorActions'], {'ok': self.okbuttonClick,
         'cancel': self.cancelClick,
         'yellow': csel.showNetworkSetup,
         'blue': csel.configure})
        self['key_yellow'] = Button(_('Network') + '...')
        self['key_blue'] = Button(_('Settings') + '...')
        menu = []
        if service:
            if service.flags & eServiceReference.mustDescent:
                if isTrashFolder(service):
                    menu.append((_('Permanently remove all deleted items'), csel.purgeAll))
                else:
                    menu.append((_('Delete'), csel.do_delete))
                    menu.append((_('Move'), csel.do_move))
                    menu.append((_('Rename'), csel.do_rename))
            else:
                menu = [(_('Delete'), csel.do_delete),
                 (_('Move'), csel.do_move),
                 (_('Delete all .txt in curent directory'), csel.do_deletetxt),
                 (_('Delete all .eit in curent directory'), csel.do_deleteeit),                        
                 (_('Copy'), csel.do_copy),
                 (_('Reset playback position'), csel.do_reset),
                 (_('Rename'), csel.do_rename),
                 (_('Start offline decode'), csel.do_decode)]
                menu.extend([ (p.description, boundFunction(p, session, service)) for p in plugins.getPlugins(PluginDescriptor.WHERE_MOVIELIST) ])
        menu.append((_('Add bookmark'), csel.do_addbookmark))
        menu.append((_('create directory'), csel.do_createdir))
        menu.append((_('Network') + '...', csel.showNetworkSetup))
        menu.append((_('Settings') + '...', csel.configure))
        self['menu'] = MenuList(menu)

    def createSummary(self):
        return MovieContextMenuSummary

    def okbuttonClick(self):
        self.close(self['menu'].getCurrent()[1])

    def cancelClick(self):
        self.close(None)
        return


class SelectionEventInfo():

    def __init__(self):
        self['Service'] = ServiceEvent()
        self.list.connectSelChanged(self.__selectionChanged)
        self.timer = eTimer()
        self.timer.callback.append(self.updateEventInfo)
        self.onShown.append(self.__selectionChanged)

    def __selectionChanged(self):
        if self.execing and self.settings['description'] == MovieList.SHOW_DESCRIPTION:
            self.timer.start(100, True)

    def updateEventInfo(self):
        serviceref = self.getCurrent()
        self['Service'].newService(serviceref)


class MovieSelectionSummary(Screen):

    def __init__(self, session, parent):
        Screen.__init__(self, session, parent=parent)
        self['name'] = StaticText('')
        self.onShow.append(self.__onShow)
        self.onHide.append(self.__onHide)

    def __onShow(self):
        self.parent.list.connectSelChanged(self.selectionChanged)
        self.selectionChanged()

    def __onHide(self):
        self.parent.list.disconnectSelChanged(self.selectionChanged)

    def selectionChanged(self):
        item = self.parent.getCurrentSelection()
        if item and item[0]:
            data = item[3]
            if data is not None and data != -1:
                name = data.txt
            elif not item[1]:
                name = '..'
            else:
                name = item[1].getName(item[0])
            if item[0].flags & eServiceReference.mustDescent:
                if len(name) > 12:
                    name = os.path.split(os.path.normpath(name))[1]
                name = '> ' + name
            self['name'].text = name
        else:
            self['name'].text = ''
        return


class MovieSelection(Screen, HelpableScreen, SelectionEventInfo, InfoBarBase):
    ALLOW_SUSPEND = Screen.SUSPEND_PAUSES

    def __init__(self, session, selectedmovie = None, timeshiftEnabled = False):
        Screen.__init__(self, session)
        HelpableScreen.__init__(self)
        if not timeshiftEnabled:
            InfoBarBase.__init__(self)
        self.initUserDefinedActions()
        self.tags = {}
        if selectedmovie:
            self.selected_tags = config.movielist.last_selected_tags.value
        else:
            self.selected_tags = None
        self.selected_tags_ele = None
        self.movemode = False
        self.bouquet_mark_edit = False
        self.feedbackTimer = None
        self.numericalTextInput = NumericalTextInput.NumericalTextInput(mapping=NumericalTextInput.MAP_SEARCH_UPCASE)
        self['chosenletter'] = Label('')
        self['chosenletter'].visible = False
        self['waitingtext'] = Label(_('Please wait... Loading list...'))
        self['DescriptionBorder'] = Pixmap()
        self['DescriptionBorder'].hide()
        if not os.path.isdir(config.movielist.last_videodir.value):
            config.movielist.last_videodir.value = defaultMoviePath()
            config.movielist.last_videodir.save()
        self.setCurrentRef(config.movielist.last_videodir.value)
        self.settings = {'listtype': config.movielist.listtype.value,
         'moviesort': config.movielist.moviesort.value,
         'description': config.movielist.description.value,
         'movieoff': config.usage.on_movie_eof.value}
        self.movieOff = self.settings['movieoff']
        self['list'] = MovieList(None, list_type=self.settings['listtype'], sort_type=self.settings['moviesort'], descr_state=self.settings['description'])
        self.list = self['list']
        self.selectedmovie = selectedmovie
        self.playGoTo = None
        title = _('Movie selection')
        self.setTitle(title)
        SelectionEventInfo.__init__(self)
        self['key_red'] = Button('')
        self['key_green'] = Button('')
        self['key_yellow'] = Button('')
        self['key_blue'] = Button('')
        self._updateButtonTexts()
        self['movie_off'] = MultiPixmap()
        self['movie_off'].hide()
        self['movie_sort'] = MultiPixmap()
        self['movie_sort'].hide()
        self['freeDiskSpace'] = self.diskinfo = DiskInfo(config.movielist.last_videodir.value, DiskInfo.FREE, update=False)
        self['InfobarActions'] = HelpableActionMap(self, 'InfobarActions', {'showMovies': (self.doPathSelect, _('Select the movie path')),
         'showRadio': (self.btn_radio, '?'),
         'showTv': (self.btn_tv, _('Home')),
         'showText': (self.btn_text, _('On end of movie'))})
        self['NumberActions'] = NumberActionMap(['NumberActions', 'InputAsciiActions'], {'gotAsciiCode': self.keyAsciiCode,
         '0': self.keyNumberGlobal,
         '1': self.keyNumberGlobal,
         '2': self.keyNumberGlobal,
         '3': self.keyNumberGlobal,
         '4': self.keyNumberGlobal,
         '5': self.keyNumberGlobal,
         '6': self.keyNumberGlobal,
         '7': self.keyNumberGlobal,
         '8': self.keyNumberGlobal,
         '9': self.keyNumberGlobal})
        self['playbackActions'] = HelpableActionMap(self, 'MoviePlayerActions', {'leavePlayer': (self.playbackStop, _('Stop')),
         'moveNext': (self.playNext, _('Play next')),
         'movePrev': (self.playPrev, _('Play previous')),
         'channelUp': (self.moveToFirstOrFirstFile, _('Go to first movie or top of list')),
         'channelDown': (self.moveToLastOrFirstFile, _('Go to first movie or last item'))})
        self['MovieSelectionActions'] = HelpableActionMap(self, 'MovieSelectionActions', {'contextMenu': (self.doContext, _('Menu')),
         'showEventInfo': (self.showEventInformation, _('Show event details'))})
        self['ColorActions'] = HelpableActionMap(self, 'ColorActions', {'red': (self.btn_red, _('Delete...')),
         'green': (self.btn_green, _('Move to other directory')),
         'yellow': (self.btn_yellow, _('Select the movie path')),
         'blue': (self.btn_blue, _('Show tag menu'))})
        self['OkCancelActions'] = HelpableActionMap(self, 'OkCancelActions', {'cancel': (self.abort, _('Exit movie list')),
         'ok': (self.itemSelected, _('Select movie'))})
        self['DirectionActions'] = HelpableActionMap(self, 'DirectionActions', {'up': (self.keyUp, _('Go up the list')),
         'down': (self.keyDown, _('Go down the list'))}, prio=-2)
        tPreview = _('Preview')
        tFwd = _('skip forward') + ' (' + tPreview + ')'
        tBack = _('skip backward') + ' (' + tPreview + ')'
        sfwd = lambda : self.seekRelative(1, config.seek.selfdefined_46.value * 90000)
        ssfwd = lambda : self.seekRelative(1, config.seek.selfdefined_79.value * 90000)
        sback = lambda : self.seekRelative(-1, config.seek.selfdefined_46.value * 90000)
        ssback = lambda : self.seekRelative(-1, config.seek.selfdefined_79.value * 90000)
        self['SeekActions'] = HelpableActionMap(self, 'InfobarSeekActions', {'playpauseService': (self.preview, _('Preview')),
         'seekFwd': (sfwd, tFwd),
         'seekFwdManual': (ssfwd, tFwd),
         'seekBack': (sback, tBack),
         'seekBackManual': (ssback, tBack)}, prio=5)
        self.onShown.append(self.onFirstTimeShown)
        self.onLayoutFinish.append(self.saveListsize)
        self.list.connectSelChanged(self.updateButtons)
        self.onClose.append(self.__onClose)
        NavigationInstance.instance.RecordTimer.on_state_change.append(self.list.updateRecordings)
        self.__event_tracker = ServiceEventTracker(screen=self, eventmap={iPlayableService.evStart: self.__serviceStarted,
         iPlayableService.evEOF: self.__evEOF})
        self.onExecBegin.append(self.asciiOn)
        return

    def asciiOn(self):
        rcinput = eRCInput.getInstance()
        rcinput.setKeyboardMode(rcinput.kmAscii)

    def asciiOff(self):
        rcinput = eRCInput.getInstance()
        rcinput.setKeyboardMode(rcinput.kmNone)

    def initUserDefinedActions(self):
        global userDefinedButtons
        global userDefinedActions
        if userDefinedButtons is None:
            userDefinedActions = {'delete': _('Delete'),
             'move': _('Move'),
             'copy': _('Copy'),
             'reset': _('Reset'),
             'tags': _('Tags'),
             'addbookmark': _('Add bookmark'),
             'bookmarks': _('Location'),
             'rename': _('Rename'),
             'gohome': _('Home'),
             'sort': _('Sort'),
             'listtype': _('List type'),
             'preview': _('Preview'),
             'movieoff': _('On end of movie')}
            for p in plugins.getPlugins(PluginDescriptor.WHERE_MOVIELIST):
                userDefinedActions['@' + p.name] = p.description

            config.movielist.btn_red = ConfigSelection(default='delete', choices=userDefinedActions)
            config.movielist.btn_green = ConfigSelection(default='move', choices=userDefinedActions)
            config.movielist.btn_yellow = ConfigSelection(default='bookmarks', choices=userDefinedActions)
            config.movielist.btn_blue = ConfigSelection(default='sort', choices=userDefinedActions)
            config.movielist.btn_radio = ConfigSelection(default='tags', choices=userDefinedActions)
            config.movielist.btn_tv = ConfigSelection(default='gohome', choices=userDefinedActions)
            config.movielist.btn_text = ConfigSelection(default='movieoff', choices=userDefinedActions)
            userDefinedButtons = {'red': config.movielist.btn_red,
             'green': config.movielist.btn_green,
             'yellow': config.movielist.btn_yellow,
             'blue': config.movielist.btn_blue,
             'Radio': config.movielist.btn_radio,
             'TV': config.movielist.btn_tv,
             'Text': config.movielist.btn_text}
        return

    def _callButton(self, name):
        if name.startswith('@'):
            item = self.getCurrentSelection()
            if isSimpleFile(item):
                name = name[1:]
                for p in plugins.getPlugins(PluginDescriptor.WHERE_MOVIELIST):
                    if name == p.name:
                        p(self.session, item[0])

            return
        try:
            a = getattr(self, 'do_' + name)
        except Exception:
            return

        a()

    def btn_red(self):
        self._callButton(config.movielist.btn_red.value)

    def btn_green(self):
        self._callButton(config.movielist.btn_green.value)

    def btn_yellow(self):
        self._callButton(config.movielist.btn_yellow.value)

    def btn_blue(self):
        self._callButton(config.movielist.btn_blue.value)

    def btn_radio(self):
        self._callButton(config.movielist.btn_radio.value)

    def btn_tv(self):
        self._callButton(config.movielist.btn_tv.value)

    def btn_text(self):
        self._callButton(config.movielist.btn_text.value)

    def keyUp(self):
        if self['list'].getCurrentIndex() < 1:
            self['list'].moveToLast()
        else:
            self['list'].moveUp()

    def keyDown(self):
        if self['list'].getCurrentIndex() == len(self['list']) - 1:
            self['list'].moveToFirst()
        else:
            self['list'].moveDown()

    def moveToFirstOrFirstFile(self):
        if self.list.getCurrentIndex() <= self.list.firstFileEntry:
            if self.list.getCurrentIndex() < 1:
                self.list.moveToLast()
            else:
                self.list.moveToFirst()
        else:
            self.list.moveToFirstMovie()

    def moveToLastOrFirstFile(self):
        if self.list.getCurrentIndex() >= self.list.firstFileEntry or self.list.firstFileEntry == len(self.list):
            if self.list.getCurrentIndex() == len(self.list) - 1:
                self.list.moveToFirst()
            else:
                self.list.moveToLast()
        else:
            self.list.moveToFirstMovie()

    def keyNumberGlobal(self, number):
        unichar = self.numericalTextInput.getKey(number)
        charstr = unichar.encode('utf-8')
        if len(charstr) == 1:
            self.list.moveToChar(charstr[0], self['chosenletter'])

    def keyAsciiCode(self):
        unichar = unichr(getPrevAsciiCode())
        charstr = unichar.encode('utf-8')
        if len(charstr) == 1:
            self.list.moveToString(charstr[0], self['chosenletter'])

    def isItemPlayable(self, index):
        item = self.list.getItem(index)
        if item:
            path = item.getPath()
            if not item.flags & eServiceReference.mustDescent:
                ext = os.path.splitext(path)[1].lower()
                if ext in IMAGE_EXTENSIONS:
                    return False
                else:
                    return True
        return False

    def goToPlayingService(self):
        service = self.session.nav.getCurrentlyPlayingServiceOrGroup()
        if service:
            path = service.getPath()
            if path:
                path = os.path.split(os.path.normpath(path))[0]
                if not path.endswith('/'):
                    path += '/'
                self.gotFilename(path, selItem=service)
                return True
        return False

    def playNext(self):
        if self.list.playInBackground:
            if self.list.moveTo(self.list.playInBackground):
                if self.isItemPlayable(self.list.getCurrentIndex() + 1):
                    self.list.moveDown()
                    self.callLater(self.preview)
            else:
                self.playGoTo = 1
                self.goToPlayingService()
        else:
            self.preview()

    def playPrev(self):
        if self.list.playInBackground:
            if self.list.moveTo(self.list.playInBackground):
                if self.isItemPlayable(self.list.getCurrentIndex() - 1):
                    self.list.moveUp()
                    self.callLater(self.preview)
            else:
                self.playGoTo = -1
                self.goToPlayingService()

    def __onClose(self):
        try:
            NavigationInstance.instance.RecordTimer.on_state_change.remove(self.list.updateRecordings)
        except Exception as e:
            print '[ML] failed to unsubscribe:', e

    def createSummary(self):
        return MovieSelectionSummary

    def updateDescription(self):
        if self.settings['description'] == MovieList.SHOW_DESCRIPTION:
            self['DescriptionBorder'].show()
            self['list'].instance.resize(eSize(self.listWidth, self.listHeight - self['DescriptionBorder'].instance.size().height()))
        else:
            self['Service'].newService(None)
            self['DescriptionBorder'].hide()
            self['list'].instance.resize(eSize(self.listWidth, self.listHeight))
        return

    def pauseService(self):
        self.playbackStop()
        self.session.nav.stopService()

    def unPauseService(self):
        self.reloadList()

    def can_delete(self, item):
        if not item:
            return False
        return canDelete(item) or isTrashFolder(item[0])

    def can_move(self, item):
        return canMove(item)

    def can_default(self, item):
        return isSimpleFile(item)

    def can_sort(self, item):
        return True

    def can_listtype(self, item):
        return True

    def can_preview(self, item):
        return isSimpleFile(item)

    def _updateButtonTexts(self):
        for k in ('red', 'green', 'yellow', 'blue'):
            btn = userDefinedButtons[k]
            self['key_' + k].setText(userDefinedActions[btn.value])

    def updateButtons(self):
        item = self.getCurrentSelection()
        for name in ('red', 'green', 'yellow', 'blue'):
            action = userDefinedButtons[name].value
            if action.startswith('@'):
                check = self.can_default
            else:
                try:
                    check = getattr(self, 'can_' + action)
                except:
                    check = self.can_default

            gui = self['key_' + name]
            if check(item):
                gui.show()
            else:
                gui.hide()

    def showEventInformation(self):
        movietitle = ""
        name2 = ""
        number = ""
        title = ""
        pathname = ""
        ext = ""
        nameext = ""
        nameext2 = ""        
        altext = ""
        namefil = ""
        namepng = ""
        movietitletxt = ""
        movietitleeit = ""
        movietitletxt2 = ""
        movietitleeit2 = ""        
        altname = ""
        item = self.getCurrentSelection()
        if item is None:
            return
        current = item[0]
        info = item[1]
        name = info and info.getName(current) or _('this recording')
        serviceHandler = eServiceCenter.getInstance()
	title = current.getPath()
	if ".iso" in title:
                dircontrol = False 
                namepng = os.path.split(title)[1]
        else:    
	    if current and (current.flags & eServiceReference.isDirectory):
	            from os import path
	            number = '%s' % (os.path.dirname(title))
                    if number.endswith("VIDEO_TS"):
                            number = number[:-9]	            
	            if number != "":
                        dircontrol = True   
                        p = os.path.split(number)
                        if not p[1]:
                                p = os.path.split(p[0])
                        namefil = '%s' % (p[1])
	    else:
                    dircontrol = False
                    namepng = name
        if dircontrol:
            if config.plugins.tmbd.movieselectionparts.value == "none":
                movietitle = number + "."
            else:
                movietitle = config.plugins.tmbd.movieselectionparts.value + "/" + namefil + "."
            pathname  = number
            namepng = namefil
        else:
            if config.plugins.tmbd.movieselectionparts.value == "none":
                nameext = title[:-2]
                movietitletxt = nameext + "txt"
                movietitleeit = nameext + "eit"               
                if fileExists(movietitletxt) or fileExists(movietitleeit):
                    movietitle = nameext
                else:
                    if title != "":
                        altext = os.path.split(title)[0]
                        movietitle = altext + "."
            else:
                altext, ext = os.path.split(title)
                nameext2 = title[:-2]
                nameext = config.plugins.tmbd.movieselectionparts.value + "/" + ext[:-2]
                movietitletxt = nameext + "txt"
                movietitleeit = nameext + "eit"
                movietitletxt2 = nameext2 + "txt"
                movietitleeit2 = nameext2 + "eit"                  
                if fileExists(movietitletxt) or fileExists(movietitleeit):
                    movietitle = nameext
                elif fileExists(movietitletxt2) or fileExists(movietitleeit2) and  not fileExists(movietitletxt) or not fileExists(movietitleeit):                        
                    movietitle = nameext2
                else:
                    namefil = self.getalttext(altext)
                    movietitle = config.plugins.tmbd.movieselectionparts.value + "/" + namefil + "."
            pathname = title
        name2 = namepng
        if movietitle:
            self.session.open(EventViewMovieSelection, movietitle, name2, pathname, current)

    def getalttext(self, filename):
        altext = ""
        name = ""
        if filename != "":
	        p = os.path.split(filename)
	        if not p[1]:
		        p = os.path.split(p)
                name = '%s' % (p[1])                  
	return name            

    def saveListsize(self):
        listsize = self['list'].instance.size()
        self.listWidth = listsize.width()
        self.listHeight = listsize.height()
        self.updateDescription()

    def onFirstTimeShown(self):
        self.onShown.remove(self.onFirstTimeShown)
        self.show()
        self.reloadList(self.selectedmovie, home=True)
        del self.selectedmovie

    def getCurrent(self):
        return self['list'].getCurrent()

    def getCurrentSelection(self):
        return self['list'].l.getCurrentSelection()

    def playAsDVD(self, path):
        try:
            from Screens import DVD
            if path.endswith('VIDEO_TS/'):
                path = os.path.split(path.rstrip('/'))[0]
            self.session.open(DVD.DVDPlayer, dvd_filelist=[path])
            return True
        except Exception as e:
            print '[ML] DVD Player not installed:', e

    def __serviceStarted(self):
        if not self.list.playInBackground:
            return
        ref = self.session.nav.getCurrentService()
        cue = ref.cueSheet()
        if not cue:
            return
        cue.setCutListEnable(2)
        cuts = cue.getCutList()
        if not cuts:
            return
        for pts, what in cuts:
            if what == 3:
                last = pts
                break
        else:
            last = cuts[0][0]

        self.doSeekTo = last
        self.callLater(self.doSeek)

    def doSeek(self, pts = None):
        if pts is None:
            pts = self.doSeekTo
        seekable = self.getSeek()
        if seekable is None:
            return
        else:
            seekable.seekTo(pts)
            return

    def getSeek(self):
        service = self.session.nav.getCurrentService()
        if service is None:
            return
        else:
            seek = service.seek()
            if seek is None or not seek.isCurrentlySeekable():
                return
            return seek

    def callLater(self, function):
        self.previewTimer = eTimer()
        self.previewTimer.callback.append(function)
        self.previewTimer.start(10, True)

    def __evEOF(self):
        playInBackground = self.list.playInBackground
        if not playInBackground:
            print 'Not playing anything in background'
            return
        else:
            current = self.getCurrent()
            self.session.nav.stopService()
            self.list.playInBackground = None
            if config.movielist.play_audio_internal.value:
                if playInBackground == current:
                    self['list'].moveDown()
                    next = self.getCurrent()
                    if not next or next == current:
                        print 'End of list'
                        return
                    path = next.getPath()
                    ext = os.path.splitext(path)[1].lower()
                    print 'Next up:', path
                    if ext in AUDIO_EXTENSIONS:
                        self.callLater(self.preview)
            return

    def preview(self):
	    current = self.getCurrent()
	    if current is not None:
		    path = current.getPath()
		    if current.flags & eServiceReference.mustDescent:
			    self.gotFilename(path)
		    else:
			    playInBackground = self.list.playInBackground
			    if playInBackground:
				    self.list.playInBackground = None
				    self.session.nav.stopService()
				    if playInBackground != current:
						# come back to play the new one
					    self.callLater(self.preview)
			    else:
				    self.list.playInBackground = current
				    self.session.nav.playService(current)

    def seekRelative(self, direction, amount):
        if self.list.playInBackground:
            seekable = self.getSeek()
            if seekable is None:
                return
            seekable.seekRelative(direction, amount)
        return

    def playbackStop(self):
        if self.list.playInBackground:
            self.list.playInBackground = None
            self.session.nav.stopService()
        return

    def itemSelected(self, answer = True):
        current = self.getCurrent()
        if current is not None:
            path = current.getPath()
            if current.flags & eServiceReference.mustDescent:
                if path.endswith('VIDEO_TS/') or os.path.exists(os.path.join(path, 'VIDEO_TS.IFO')):
                    if self.playAsDVD(path):
                        return
                self.gotFilename(path)
            else:
                ext = os.path.splitext(path)[1].lower()
                if config.movielist.play_audio_internal.value and ext in AUDIO_EXTENSIONS:
                    self.preview()
                    return
                if self.list.playInBackground:
                    self.session.nav.stopService()
                    self.list.playInBackground = None
                    self.callLater(self.itemSelected)
                    return
                if ext in IMAGE_EXTENSIONS:
                    try:
                        from Plugins.Extensions.PicturePlayer import ui
                        filelist = []
                        index = 0
                        for item in self.list.list:
                            p = item[0].getPath()
                            if p == path:
                                index = len(filelist)
                            if os.path.splitext(p)[1].lower() in IMAGE_EXTENSIONS:
                                filelist.append(((p, False), None))

                        self.session.open(ui.Pic_Full_View, filelist, index, path)
                    except Exception as ex:
                        print '[ML] Cannot display', str(ex)

                    return
                if config.movielist.play.value:
                    if current and (current.flags & eServiceReference.isDirectory):
                        self.movieSelected()
                    else:
                      self.session.openWithCallback(self.movieSelected2, MovieSelectionPreviem, current, path)
                else:
                    self.movieSelected()
        return                    

    def movieSelected2(self, confirmed):
        if confirmed:
            current = self.getCurrent()
            if current is not None:
                self.saveconfig()
                self.close(current)
        else:
            pass
        return

    def movieSelected(self):
        current = self.getCurrent()
        if current is not None:
            self.saveconfig()
            self.close(current)
        return    

    def doContext(self):
        current = self.getCurrent()
        if current is not None:
            self.session.openWithCallback(self.doneContext, MovieContextMenu, self, current)
        return

    def doneContext(self, action):
        if action is not None:
            action()
        return

    def saveLocalSettings(self):
        try:
            path = os.path.join(config.movielist.last_videodir.value, '.e2settings.pkl')
            pickle.dump(self.settings, open(path, 'wb'))
        except Exception as e:
            print 'Failed to save settings to %s: %s' % (path, e)

        config.movielist.moviesort.value = self.settings['moviesort']
        config.movielist.listtype.value = self.settings['listtype']
        config.movielist.description.value = self.settings['description']
        config.usage.on_movie_eof.value = self.settings['movieoff']

    def loadLocalSettings(self):
        if config.movielist.settings_per_directory.value:
            try:
                path = os.path.join(config.movielist.last_videodir.value, '.e2settings.pkl')
                updates = pickle.load(open(path, 'rb'))
                self.applyConfigSettings(updates)
            except IOError as e:
                updates = {'listtype': config.movielist.listtype.default,
                 'moviesort': config.movielist.moviesort.default,
                 'description': config.movielist.description.default,
                 'movieoff': config.usage.on_movie_eof.default}
                self.applyConfigSettings(updates)
            except Exception as e:
                print 'Failed to load settings from %s: %s' % (path, e)

        else:
            updates = {'listtype': config.movielist.listtype.value,
             'moviesort': config.movielist.moviesort.value,
             'description': config.movielist.description.value,
             'movieoff': config.usage.on_movie_eof.value}
            self.applyConfigSettings(updates)

    def applyConfigSettings(self, updates):
        needUpdate = 'description' in updates and updates['description'] != self.settings['description']
        self.settings.update(updates)
        if needUpdate:
            self['list'].setDescriptionState(self.settings['description'])
            self.updateDescription()
        if self.settings['listtype'] != self['list'].list_type:
            self['list'].setListType(self.settings['listtype'])
            needUpdate = True
        if self.settings['moviesort'] != self['list'].sort_type:
            self['list'].setSortType(self.settings['moviesort'])
            needUpdate = True
        if self.settings['movieoff'] != self.movieOff:
            self.movieOff = self.settings['movieoff']
            needUpdate = True
        config.movielist.moviesort.value = self.settings['moviesort']
        config.movielist.listtype.value = self.settings['listtype']
        config.movielist.description.value = self.settings['description']
        config.usage.on_movie_eof.value = self.settings['movieoff']
        return needUpdate

    def sortBy(self, newType):
        self.settings['moviesort'] = newType
        self.saveLocalSettings()
        self.setSortType(newType)
        self.reloadList()

    def listType(self, newType):
        self.settings['listtype'] = newType
        self.saveLocalSettings()
        self.setListType(newType)
        self.reloadList()

    def showDescription(self, newType):
        self.settings['description'] = newType
        self.saveLocalSettings()
        self.setDescriptionState(newType)
        self.updateDescription()

    def abort(self):
        global playlist
        del playlist[:]
        if self.list.playInBackground:
            self.list.playInBackground = None
            self.session.nav.stopService()
            self.callLater(self.abort)
            return
        else:
            self.saveconfig()
            self.close(None)
            return

    def saveconfig(self):
        config.movielist.last_selected_tags.value = self.selected_tags

    def configure(self):
        self.session.openWithCallback(self.configureDone, MovieBrowserConfiguration)

    def configureDone(self, result):
        if result:
            self.applyConfigSettings({'listtype': config.movielist.listtype.value,
             'moviesort': config.movielist.moviesort.value,
             'description': config.movielist.description.value,
             'movieoff': config.usage.on_movie_eof.value})
            self.saveLocalSettings()
            self._updateButtonTexts()
            self.reloadList()

    def getTagDescription(self, tag):
        return tag

    def updateTags(self):
        self.tags = self['list'].tags

    def setListType(self, type):
        self['list'].setListType(type)

    def setDescriptionState(self, val):
        self['list'].setDescriptionState(val)

    def setSortType(self, type):
        self['list'].setSortType(type)

    def setCurrentRef(self, path):
        self.current_ref = eServiceReference('2:0:1:0:0:0:0:0:0:0:' + path)
        self.current_ref.setName('8192:jpg 8192:png 8192:gif 8192:bmp')

    def reloadList(self, sel = None, home = False):
        self.reload_sel = sel
        self.reload_home = home
        self['waitingtext'].visible = True
        self.callLater(self.reloadWithDelay)

    def reloadWithDelay(self):
        if not os.path.isdir(config.movielist.last_videodir.value):
            path = defaultMoviePath()
            config.movielist.last_videodir.value = path
            config.movielist.last_videodir.save()
            self.setCurrentRef(path)
            self['freeDiskSpace'].path = path
        if self.reload_sel is None:
            self.reload_sel = self.getCurrent()
        self['list'].reload(self.current_ref, self.selected_tags)
        self.updateTags()
        title = _('Recorded files...')
        if config.usage.setup_level.index >= 2:
            title += '  ' + config.movielist.last_videodir.value
        if self.selected_tags is not None:
            title += ' - ' + ','.join(self.selected_tags)
        self.setTitle(title)
        self.displayMovieOffStatus()
        self.displaySortStatus()
        if not (self.reload_sel and self['list'].moveTo(self.reload_sel)):
            if self.reload_home:
                self['list'].moveToFirstMovie()
        self['freeDiskSpace'].update()
        self['waitingtext'].visible = False
        self.createPlaylist()
        if self.playGoTo:
            if self.isItemPlayable(self.list.getCurrentIndex() + 1):
                if self.playGoTo > 0:
                    self.list.moveDown()
                else:
                    self.list.moveUp()
                self.playGoTo = None
                self.callLater(self.preview)
        return

    def doPathSelect(self):
        self.session.openWithCallback(self.gotFilename, MovieLocationBox, _('Please select the movie path...'), config.movielist.last_videodir.value)

    def gotFilename(self, res, selItem = None):
        if not res:
            return
        if not res.endswith('/'):
            res += '/'
        currentDir = config.movielist.last_videodir.value
        if res != currentDir:
            if os.path.isdir(res):
                config.movielist.last_videodir.value = res
                config.movielist.last_videodir.save()
                self.loadLocalSettings()
                self.setCurrentRef(res)
                self['freeDiskSpace'].path = res
                if selItem:
                    self.reloadList(home=True, sel=selItem)
                else:
                    self.reloadList(home=True, sel=eServiceReference('2:0:1:0:0:0:0:0:0:0:' + currentDir))
            else:
                self.session.open(MessageBox, _('Directory %s does not exist.') % res, type=MessageBox.TYPE_ERROR, timeout=5)

    def showAll(self):
        self.selected_tags_ele = None
        self.selected_tags = None
        self.reloadList(home=True)
        return

    def showTagsN(self, tagele):
        if not self.tags:
            self.showTagWarning()
        elif not tagele or self.selected_tags and tagele.value in self.selected_tags or tagele.value not in self.tags:
            self.showTagsMenu(tagele)
        else:
            self.selected_tags_ele = tagele
            self.selected_tags = self.tags[tagele.value]
            self.reloadList(home=True)

    def showTagsFirst(self):
        self.showTagsN(config.movielist.first_tags)

    def showTagsSecond(self):
        self.showTagsN(config.movielist.second_tags)

    def can_tags(self, item):
        return self.tags

    def do_tags(self):
        self.showTagsN(None)
        return

    def tagChosen(self, tag):
        if tag is not None:
            if tag[1] is None:
                self.showAll()
                return
            self.selected_tags = self.tags[tag[0]]
            if self.selected_tags_ele:
                self.selected_tags_ele.value = tag[0]
                self.selected_tags_ele.save()
            self.reloadList(home=True)
        return

    def showTagsMenu(self, tagele):
        self.selected_tags_ele = tagele
        lst = [(_('show all tags'), None)] + [ (tag, self.getTagDescription(tag)) for tag in self.tags ]
        self.session.openWithCallback(self.tagChosen, ChoiceBox, title=_('Please select tag to filter...'), list=lst)
        return

    def showTagWarning(self):
        self.session.open(MessageBox, _('No tags are set on these movies.'), MessageBox.TYPE_ERROR)

    def selectMovieLocation(self, title, callback):
        bookmarks = [('(' + _('Other') + '...)', None)]
        inlist = []
        for d in config.movielist.videodirs.value:
            d = os.path.normpath(d)
            bookmarks.append((d, d))
            inlist.append(d)

        for p in Components.Harddisk.harddiskmanager.getMountedPartitions():
            d = os.path.normpath(p.mountpoint)
            if d in inlist:
                bookmarks[bookmarks.index((d, d))] = (p.tabbedDescription(), d)
            else:
                bookmarks.append((p.tabbedDescription(), d))
            inlist.append(d)

        for d in last_selected_dest:
            if d not in inlist:
                bookmarks.append((d, d))

        self.onMovieSelected = callback
        self.movieSelectTitle = title
        self.session.openWithCallback(self.gotMovieLocation, ChoiceBox, title=title, list=bookmarks)
        return

    def gotMovieLocation(self, choice):
        if not choice:
            self.onMovieSelected(None)
            del self.onMovieSelected
            return
        else:
            if isinstance(choice, tuple):
                if choice[1] is None:
                    self.session.openWithCallback(self.gotMovieLocation, MovieLocationBox, self.movieSelectTitle, config.movielist.last_videodir.value)
                    return
                choice = choice[1]
            choice = os.path.normpath(choice)
            self.rememberMovieLocation(choice)
            self.onMovieSelected(choice)
            del self.onMovieSelected
            return

    def rememberMovieLocation(self, where):
        if where in last_selected_dest:
            last_selected_dest.remove(where)
        last_selected_dest.insert(0, where)
        if len(last_selected_dest) > 5:
            del last_selected_dest[-1]

    def can_bookmarks(self, item):
        return True

    def do_bookmarks(self):
        self.selectMovieLocation(title=_('Please select the movie path...'), callback=self.gotFilename)

    def can_addbookmark(self, item):
        return True

    def do_addbookmark(self):
        path = config.movielist.last_videodir.value
        if path in config.movielist.videodirs.value:
            if len(path) > 40:
                path = '...' + path[-40:]
            self.session.openWithCallback(self.removeBookmark, MessageBox, _('Do you really want to remove your bookmark of %s?') % path)
        else:
            config.movielist.videodirs.value += [path]
            config.movielist.videodirs.save()

    def removeBookmark(self, yes):
        if not yes:
            return
        path = config.movielist.last_videodir.value
        bookmarks = config.movielist.videodirs.value
        bookmarks.remove(path)
        config.movielist.videodirs.value = bookmarks
        config.movielist.videodirs.save()

    def can_createdir(self, item):
        return True

    def do_createdir(self):
        from Screens.VirtualKeyBoard import VirtualKeyBoard
        self.session.openWithCallback(self.createDirCallback, VirtualKeyBoard, title=_('Please enter name of the new directory'), text='')

    def createDirCallback(self, name):
        if not name:
            return
        else:
            msg = None
            try:
                path = os.path.join(config.movielist.last_videodir.value, name)
                os.mkdir(path)
                if not path.endswith('/'):
                    path += '/'
                self.reloadList(sel=eServiceReference('2:0:1:0:0:0:0:0:0:0:' + path))
            except OSError as e:
                print 'Error %s:' % e.errno, e
                if e.errno == 17:
                    msg = _('The path %s already exists.') % name
                else:
                    msg = _('Error') + '\n' + str(e)
            except Exception as e:
                print '[ML] Unexpected error:', e
                msg = _('Error') + '\n' + str(e)

            if msg:
                self.session.open(MessageBox, msg, type=MessageBox.TYPE_ERROR, timeout=5)
            return

    def can_rename(self, item):
        return canMove(item)

    def do_rename(self):
        item = self.getCurrentSelection()
        if not canMove(item):
            return
        if isFolder(item):
            p = os.path.split(item[0].getPath())
            if not p[1]:
                p = os.path.split(p[0])
            name = p[1]
        else:
            info = item[1]
            name = info.getName(item[0])
        from Screens.VirtualKeyBoard import VirtualKeyBoard
        self.session.openWithCallback(self.renameCallback, VirtualKeyBoard, title=_('Rename'), text=name)

    def do_decode(self):
        from ServiceReference import ServiceReference
        item = self.getCurrentSelection()
        info = item[1]
        serviceref = ServiceReference(None, reftype=eServiceReference.idDVB, path=item[0].getPath())
        name = info.getName(item[0]) + ' - decoded'
        description = info.getInfoString(item[0], iServiceInformation.sDescription)
        recording = RecordTimer.RecordTimerEntry(serviceref, int(time.time()), int(time.time()) + 3600, name, description, 0, dirname=preferredTimerPath())
        recording.dontSave = True
        recording.autoincrease = True
        recording.setAutoincreaseEnd()
        self.session.nav.RecordTimer.record(recording, ignoreTSC=True)
        return

    def renameCallback(self, name):
        if not name:
            return
        else:
            name = name.strip()
            item = self.getCurrentSelection()
            if item and item[0]:
                try:
                    path = item[0].getPath().rstrip('/')
                    meta = path + '.meta'
                    if os.path.isfile(meta):
                        metafile = open(meta, 'r+')
                        sid = metafile.readline()
                        oldtitle = metafile.readline()
                        rest = metafile.read()
                        metafile.seek(0)
                        metafile.write('%s%s\n%s' % (sid, name, rest))
                        metafile.truncate()
                        metafile.close()
                        index = self.list.getCurrentIndex()
                        info = self.list.list[index]
                        if hasattr(info[3], 'txt'):
                            info[3].txt = name
                        else:
                            self.list.invalidateCurrentItem()
                        return
                    pathname, filename = os.path.split(path)
                    newpath = os.path.join(pathname, name)
                    msg = None
                    print '[ML] rename', path, 'to', newpath
                    os.rename(path, newpath)
                    self.reloadList(sel=eServiceReference('2:0:1:0:0:0:0:0:0:0:' + newpath))
                except OSError as e:
                    print 'Error %s:' % e.errno, e
                    if e.errno == 17:
                        msg = _('The path %s already exists.') % name
                    else:
                        msg = _('Error') + '\n' + str(e)
                except Exception as e:
                    import traceback
                    print '[ML] Unexpected error:', e
                    traceback.print_exc()
                    msg = _('Error') + '\n' + str(e)

                if msg:
                    self.session.open(MessageBox, msg, type=MessageBox.TYPE_ERROR, timeout=5)
            return

    def do_reset(self):
        current = self.getCurrent()
        if current:
            resetMoviePlayState(current.getPath() + '.cuts', current)
            self['list'].invalidateCurrentItem()

    def do_deletetxt(self):
        number = ""
        item = self.getCurrentSelection()
        if item is None:
            return        
        current = item[0]
	title = current.getPath()
	number = '%s' % (os.path.dirname(title))
	if number != "":
                 result = True
        else:
                result = False
	if result == True:
		self.session.openWithCallback(self.deletetxtConfirmed, MessageBox, _("Do you really want to delete all .txt in %s?") % (number))
	else:
		self.session.openWithCallback(self.close, MessageBox, _("You cannot delete this!"), MessageBox.TYPE_ERROR)            

    def deletetxtConfirmed(self, confirmed):
        number = ""
        item = self.getCurrentSelection()
        if item is None:
            return      
        current = item[0]
	title = current.getPath()
	number = '%s' % (os.path.dirname(title))
	if number != "":
                result = True
        else:
                result = False                        
	if not confirmed:
		return self.close()
	if result == False:
		self.session.openWithCallback(self.close, MessageBox, _("Delete failed!"), MessageBox.TYPE_ERROR)
	else:
                number = number + "/"
                os.system("rm %s*.*txt" % number)
		#self.close()

    def do_deleteeit(self):
            number = ""
            item = self.getCurrentSelection()
            if item is None:
               return            
            current = item[0]
	    title = current.getPath()
	    number = '%s' % (os.path.dirname(title))
	    if number != "":
                    result = True
            else:
                    result = False
	    if result == True:
		    self.session.openWithCallback(self.deleteeitConfirmed, MessageBox, _("Do you really want to delete all .eit in %s?") % (number))
	    else:
		    self.session.openWithCallback(self.close, MessageBox, _("You cannot delete this!"), MessageBox.TYPE_ERROR)

    def deleteeitConfirmed(self, confirmed):
            number = ""
            item = self.getCurrentSelection()
            if item is None:
                return            
            current = item[0]
	    title = current.getPath()
	    number = '%s' % (os.path.dirname(title))
	    if number != "":
                    result = True
            else:
                    result = False                        
	    if not confirmed:
		    return self.close()
	    if result == False:
		    self.session.openWithCallback(self.close, MessageBox, _("Delete failed!"), MessageBox.TYPE_ERROR)
	    else:
                    number = number + "/"
                    os.system("rm %s*.*eit" % number)
		   # self.close()		
			
    def do_move(self):
        item = self.getCurrentSelection()
        if canMove(item):
            current = item[0]
            info = item[1]
            if info is None:
                return
            name = info and info.getName(current) or _('this recording')
            path = os.path.normpath(current.getPath())
            title = _('Select destination for:') + ' ' + name
            bookmarks = [('(' + _('Other') + '...)', None)]
            inlist = []
            try:
                base = os.path.split(path)[0]
                for fn in os.listdir(base):
                    if not fn.startswith('.'):
                        d = os.path.join(base, fn)
                        if os.path.isdir(d) and d not in inlist:
                            bookmarks.append((fn, d))
                            inlist.append(d)

            except Exception as e:
                print '[MovieSelection]', e

            for d in last_selected_dest:
                if d not in inlist:
                    bookmarks.append((d, d))

            for d in config.movielist.videodirs.value:
                d = os.path.normpath(d)
                bookmarks.append((d, d))
                inlist.append(d)

            for p in Components.Harddisk.harddiskmanager.getMountedPartitions():
                d = os.path.normpath(p.mountpoint)
                if d not in inlist:
                    bookmarks.append((p.description, d))
                    inlist.append(d)

            self.onMovieSelected = self.gotMoveMovieDest
            self.movieSelectTitle = title
            self.session.openWithCallback(self.gotMovieLocation, ChoiceBox, title=title, list=bookmarks)
        return

    def gotMoveMovieDest(self, choice):
        if not choice:
            return
        else:
            dest = os.path.normpath(choice)
            try:
                item = self.getCurrentSelection()
                current = item[0]
                if item[1] is None:
                    name = None
                else:
                    name = item[1].getName(current)
                moveServiceFiles(current, dest, name)
                self['list'].removeService(current)
            except Exception as e:
                self.session.open(MessageBox, str(e), MessageBox.TYPE_ERROR)

            return

    def can_copy(self, item):
        return canCopy(item)

    def do_copy(self):
        item = self.getCurrentSelection()
        if canMove(item):
            current = item[0]
            info = item[1]
            if info is None:
                return
            name = info and info.getName(current) or _('this recording')
            self.selectMovieLocation(title=_('Select copy destination for:') + ' ' + name, callback=self.gotCopyMovieDest)
        return

    def gotCopyMovieDest(self, choice):
        if not choice:
            return
        else:
            dest = os.path.normpath(choice)
            try:
                item = self.getCurrentSelection()
                current = item[0]
                if item[1] is None:
                    name = None
                else:
                    name = item[1].getName(current)
                copyServiceFiles(current, dest, name)
            except Exception as e:
                self.session.open(MessageBox, str(e), MessageBox.TYPE_ERROR)

            return

    def stopTimer(self, timer):
        if timer.isRunning():
            if timer.repeated:
                timer.enable()
                timer.processRepeated(findRunningEvent=False)
                self.session.nav.RecordTimer.doActivate(timer)
            else:
                timer.afterEvent = RecordTimer.AFTEREVENT.NONE
                NavigationInstance.instance.RecordTimer.removeEntry(timer)

    def onTimerChoice(self, choice):
        if isinstance(choice, tuple) and choice[1]:
            choice, timer = choice[1]
            if not choice:
                return
            if 's' in choice:
                self.stopTimer(timer)
            if 'd' in choice:
                self.delete(True)

    def do_delete(self):
        self.delete()

    def delete(self, *args):
        movietitle = ""
        name2 = ""
        number = ""
        title = ""
        covers = ""
        ext = ""
        namedir = ""
        ngettext = ""
        if args and not args[0]:
            return
        else:
            item = self.getCurrentSelection()
            if not canDelete(item):
                if item and isTrashFolder(item[0]):
                    self.purgeAll()
                return
            current = item[0]
            info = item[1]
            cur_path = os.path.realpath(current.getPath())
            st = os.stat(cur_path)
            name = info and info.getName(current) or _('this recording')
	    title = current.getPath()
	    if ".iso" in title:
                    dircontrol = False 
                    name2 = os.path.split(title)[1]
            else:    
	        if current and (current.flags & eServiceReference.isDirectory):
	                from os import path
	                number = '%s' % (os.path.dirname(title))
	                if number != "":
                            dircontrol = True   
                            p = os.path.split(number)
                            if not p[1]:
                                    p = os.path.split(p[0])
                            namedir = '%s' % (p[1])
	        else:
                        dircontrol = False
                        name2 = name
            if dircontrol:
                if config.plugins.tmbd.movieselectionparts.value == "none":
                    movietitle = number
                else:
                    movietitle = config.plugins.tmbd.movieselectionparts.value + "/" + namedir
                name2 = namedir    
            else:
                if config.plugins.tmbd.movieselectionparts.value == "none":
                    movietitle = title[:-2]
                else:
                    if title != "":
                        ext = os.path.split(title)[1]
                        movietitle = config.plugins.tmbd.movieselectionparts.value + "/" + ext[:-2]
            are_you_sure = _('Do you really want to delete %s?') % name
            if current.flags & eServiceReference.mustDescent:
                files = 0
                subdirs = 0
                if args:
                    msg = ''
                    if config.usage.movielist_trashcan.value:
                        try:
                            trash = Tools.Trashcan.createTrashFolder(cur_path)
                            trash = os.path.join(trash, os.path.split(cur_path)[1])
                            os.mkdir(trash)
                            for root, dirnames, filenames in os.walk(cur_path):
                                trashroot = os.path.join(trash, root[len(cur_path) + 1:])
                                for fn in filenames:
                                    print 'Move %s -> %s' % (os.path.join(root, fn), os.path.join(trashroot, fn))
                                    os.rename(os.path.join(root, fn), os.path.join(trashroot, fn))

                                for dn in dirnames:
                                    print 'MkDir', os.path.join(trashroot, dn)
                                    os.mkdir(os.path.join(trashroot, dn))

                            for root, dirnames, filenames in os.walk(cur_path, topdown=False):
                                for dn in dirnames:
                                    print 'rmdir', os.path.join(trashroot, dn)
                                    os.rmdir(os.path.join(root, dn))

                            os.rmdir(cur_path)
                            self['list'].removeService(current)
                            self.showActionFeedback(_('Deleted') + ' ' + name)
                            return
                        except OSError as e:
                            print '[MovieSelection] Cannot move to trash', e
                            if e.errno == 18:
                                msg = _('Cannot move files on a different disk or system to the trash can') + '. '
                            else:
                                msg = _('Cannot move to trash can') + '.\n' + str(e) + '\n'
                        except Exception as e:
                            print '[MovieSelection] Weird error moving to trash', e
                            msg = _('Cannot move to trash can') + '\n' + str(e) + '\n'

                    msg += _('Sorry, deleting directories can (for now) only be done through the trash can.')
                    self.session.open(MessageBox, msg, MessageBox.TYPE_ERROR)
                    return
                for fn in os.listdir(cur_path):
                    if fn != '.' and fn != '..':
                        ffn = os.path.join(cur_path, fn)
                        if os.path.isdir(ffn):
                            subdirs += 1
                        else:
                            files += 1

                if files or subdirs:
                    msg = _("Directory contains %d file(s) and %d sub-directories.\n") % (files,subdirs) + are_you_sure
                    if isInTrashFolder(current):
                        msg = _('Deleted items') + '\n' + msg
                        callback = self.purgeConfirmed
                    else:
                        callback = self.delete
                    self.session.openWithCallback(callback, MessageBox, msg)
                    return
                try:
                    os.rmdir(cur_path)
                except Exception as e:
                    print '[MovieSelection] Failed delete', e
                    self.session.open(MessageBox, _('Delete failed!') + '\n' + str(e), MessageBox.TYPE_ERROR)
                else:
                    self['list'].removeService(current)
                    self.showActionFeedback(_('Deleted') + ' ' + name)

            else:
                if not args:
                    rec_filename = os.path.split(current.getPath())[1]
                    if rec_filename.endswith('.ts'):
                        rec_filename = rec_filename[:-3]
                    for timer in NavigationInstance.instance.RecordTimer.timer_list:
                        if timer.isRunning() and not timer.justplay and rec_filename in timer.Filename:
                            choices = [(_('Cancel'), None), (_('Stop recording'), ('s', timer)), (_('Stop recording and delete'), ('sd', timer))]
                            self.session.openWithCallback(self.onTimerChoice, ChoiceBox, title=_('Recording in progress') + ':\n%s' % name, list=choices)
                            return

                    if time.time() - st.st_mtime < 5:
                        if not args:
                            self.session.openWithCallback(self.delete, MessageBox, _('File appears to be busy.\n') + are_you_sure)
                            return
                if config.usage.movielist_trashcan.value:
                    try:
                        covers = "/media/hdd/covers/" + name2
                        if dircontrol:
                                eConsoleAppContainer().execute("rm -f '%s'" % movietitle + ".eit")
                                eConsoleAppContainer().execute("rm -f '%s'" % movietitle + ".txt")                                
                        else:        
                                eConsoleAppContainer().execute("rm -f '%s'" % movietitle + "eit")
                                eConsoleAppContainer().execute("rm -f '%s'" % movietitle + "txt")
                        eConsoleAppContainer().execute("rm -f '%s'" % covers + ".jpg")
                        eConsoleAppContainer().execute("rm -f '%s'" % covers + "_big.jpg") 
                        trash = Tools.Trashcan.createTrashFolder(cur_path)
                        if cur_path.startswith(trash):
                            msg = _('Deleted items') + '\n'
                        else:
                            moveServiceFiles(current, trash, name, allowCopy=False)
                            self['list'].removeService(current)
                            from Screens.InfoBarGenerics import delResumePoint
                            delResumePoint(current)
                            self.showActionFeedback(_('Deleted') + ' ' + name)
                            return
                    except OSError as e:
                        print '[MovieSelection] Cannot move to trash', e
                        if e.errno == 18:
                            msg = _('Cannot move files on a different disk or system to the trash can') + '. '
                        else:
                            msg = _('Cannot move to trash can') + '.\n' + str(e) + '\n'
                    except Exception as e:
                        print '[MovieSelection] Weird error moving to trash', e
                        msg = _('Cannot move to trash can') + '\n' + str(e) + '\n'

                else:
                    msg = ''
                self.session.openWithCallback(self.deleteConfirmed, MessageBox, msg + are_you_sure)
            return

    def deleteConfirmed(self, confirmed):
        movietitle = ""
        name2 = ""
        number = ""
        title = ""
        covers = ""
        ext = ""
        namedir = "" 
        if not confirmed:
            return
        else:
            item = self.getCurrentSelection()
            if item is None:
                return
            current = item[0]
            info = item[1]
            name = info and info.getName(current) or _('this recording')
            serviceHandler = eServiceCenter.getInstance()
	    title = current.getPath()
	    if ".iso" in title:
                    dircontrol = False 
                    name2 = os.path.split(title)[1]
            else:    
	        if current and (current.flags & eServiceReference.isDirectory):
	                from os import path
	                number = '%s' % (os.path.dirname(title))
	                if number != "":
                            dircontrol = True   
                            p = os.path.split(number)
                            if not p[1]:
                                    p = os.path.split(p[0])
                            namedir = '%s' % (p[1])
                            name2 = namedir
	        else:
                        dircontrol = False
                        name2 = name
            if dircontrol:
                if config.plugins.tmbd.movieselectionparts.value == "none":
                    movietitle = number
                else:
                    movietitle = config.plugins.tmbd.movieselectionparts.value + "/" + namedir
            else:
                if config.plugins.tmbd.movieselectionparts.value == "none":
                    movietitle = title[:-2]
                else:
                    if title != "":
                        ext = os.path.split(title)[1]
                        movietitle = config.plugins.tmbd.movieselectionparts.value + "/" + ext[:-2]            
            offline = serviceHandler.offlineOperations(current)
            try:
                if offline is None:
                    from enigma import eBackgroundFileEraser
                    eBackgroundFileEraser.getInstance().erase(os.path.realpath(current.getPath()))
                elif offline.deleteFromDisk(0):
                    raise Exception, 'Offline delete failed'
                covers = "/media/hdd/covers/" + name2
                if dircontrol:
                        eConsoleAppContainer().execute("rm -f '%s'" % movietitle + ".eit")
                        eConsoleAppContainer().execute("rm -f '%s'" % movietitle + ".txt")                                
                else:        
                        eConsoleAppContainer().execute("rm -f '%s'" % movietitle + "eit")
                        eConsoleAppContainer().execute("rm -f '%s'" % movietitle + "txt")
                eConsoleAppContainer().execute("rm -f '%s'" % covers + ".jpg")
                eConsoleAppContainer().execute("rm -f '%s'" % covers + "_big.jpg")                 
                self['list'].removeService(current)
                from Screens.InfoBarGenerics import delResumePoint
                delResumePoint(current)
                self.showActionFeedback(_('Deleted') + ' ' + name)
            except Exception as ex:
                self.session.open(MessageBox, _('Delete failed!') + '\n' + name + '\n' + str(ex), MessageBox.TYPE_ERROR)

            return

    def purgeAll(self):
        recordings = self.session.nav.getRecordings()
        next_rec_time = -1
        msg = _('Permanently delete all recordings in the trash can?')
        if not recordings:
            next_rec_time = self.session.nav.RecordTimer.getNextRecordingTime()
        if recordings or next_rec_time > 0 and next_rec_time - time.time() < 120:
            msg += '\n' + _('Recording(s) are in progress or coming up in few seconds!')
        self.session.openWithCallback(self.purgeConfirmed, MessageBox, msg)

    def purgeConfirmed(self, confirmed):
        if not confirmed:
            return
        item = self.getCurrentSelection()
        current = item[0]
        cur_path = os.path.realpath(current.getPath())
        Tools.Trashcan.cleanAll(cur_path)

    def showNetworkSetup(self):
        import NetworkSetup
        self.session.open(NetworkSetup.NetworkAdapterSelection)

    def showActionFeedback(self, text):
        if self.feedbackTimer is None:
            self.feedbackTimer = eTimer()
            self.feedbackTimer.callback.append(self.hideActionFeedback)
        else:
            self.feedbackTimer.stop()
        self.feedbackTimer.start(3000, 1)
        self.diskinfo.setText(text)
        return

    def hideActionFeedback(self):
        print '[ML] hide feedback'
        self.diskinfo.update()

    def can_gohome(self, item):
        return True

    def do_gohome(self):
        self.gotFilename(defaultMoviePath())

    def do_sort(self):
        index = 0
        for index, item in enumerate(l_moviesort):
            if int(item[0]) == int(config.movielist.moviesort.value):
                break

        if index >= len(l_moviesort) - 1:
            index = 0
        else:
            index += 1
        sorttext = l_moviesort[index][2]
        if config.movielist.btn_red.value == 'sort':
            self['key_red'].setText(sorttext)
        if config.movielist.btn_green.value == 'sort':
            self['key_green'].setText(sorttext)
        if config.movielist.btn_yellow.value == 'sort':
            self['key_yellow'].setText(sorttext)
        if config.movielist.btn_blue.value == 'sort':
            self['key_blue'].setText(sorttext)
        self.sorttimer = eTimer()
        self.sorttimer.callback.append(self._updateButtonTexts)
        self.sorttimer.start(1500, True)
        self.sortBy(int(l_moviesort[index][0]))
        self['movie_sort'].setPixmapNum(int(l_moviesort[index][0]) - 1)

    def do_listtype(self):
        index = 0
        for index, item in enumerate(l_listtype):
            if int(item[0]) == int(config.movielist.listtype.value):
                break

        if index >= len(l_listtype) - 1:
            index = 0
        else:
            index += 1
        self.listType(int(l_listtype[index][0]))

    def do_preview(self):
        self.preview()

    def displaySortStatus(self):
        self['movie_sort'].setPixmapNum(int(config.movielist.moviesort.value) - 1)
        self['movie_sort'].show()

    def do_movieoff(self):
        self.setNextMovieOffStatus()
        self.displayMovieOffStatus()

    def displayMovieOffStatus(self):
        self['movie_off'].setPixmapNum(config.usage.on_movie_eof.getIndex())
        self['movie_off'].show()

    def setNextMovieOffStatus(self):
        config.usage.on_movie_eof.selectNext()
        self.settings['movieoff'] = config.usage.on_movie_eof.value
        if config.movielist.settings_per_directory.value:
            self.saveLocalSettings()

    def createPlaylist(self):
        items = playlist
        del items[:]
        for index, item in enumerate(self['list']):
            if item:
                item = item[0]
                path = item.getPath()
                if not item.flags & eServiceReference.mustDescent:
                    ext = os.path.splitext(path)[1].lower()
                    if ext in IMAGE_EXTENSIONS:
                        continue
                    else:
                        items.append(item)


playlist = []

class EventViewMovieSelection(Screen):
    skin_hd = """
		<screen name="EventViewMovieSelection" position="90,90" size="1100,570" title="EventViewMovieSelection">
		<eLabel backgroundColor="#00bbbbbb" position="0,0" size="1100,2" />
		<widget font="Regular;22" name="title" position="20,20" size="740,28" transparent="1" valign="center" />
		<widget alphatest="blend" name="starsbg" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/starsbar_empty.png" position="770,10" size="210,21" zPosition="2" />
		<widget font="Regular;20" halign="left" name="ratinglabel" foregroundColor="#00f0b400" position="770,34" size="210,23" transparent="1" />
		<widget font="Regular;20" name="voteslabel" halign="left" position="770,57" size="330,23" foregroundColor="#00f0b400" transparent="1" />
		<widget alphatest="blend" name="poster" position="30,60" size="285,398" />
		<widget font="Regular;20" name="castlabel" position="320,351" size="760,210" transparent="1" />
		<widget font="Regular;20" name="extralabel" position="320,62" size="760,285" transparent="1" />
		</screen>"""
    skin_hd1 = """
                <screen name="EventViewMovieSelection" position="0,0" size="1280,720" title="EventViewMovieSelection">
		<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/Backdrop.png" position="0,0" size="1280,720" transparent="1" zPosition="-3" alphatest="on" />
		<widget font="Regular;26" name="title" foregroundColor="#005395c3" backgroundColor="#907F6B" position="253,30" size="740,28" zPosition="1" transparent="1" halign="center" />
		<widget alphatest="blend" name="starsbg" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/starsbar_empty.png" position="41,495" size="210,21" zPosition="2" />
		<widget font="Regular;20" halign="left" name="ratinglabel" foregroundColor="#00f0b400" zPosition="1" position="41,520" size="320,23" transparent="1" />
		<widget font="Regular;20" name="voteslabel" halign="left" position="41,548" size="320,23" zPosition="1" foregroundColor="#00f0b400" transparent="1" />
		<widget alphatest="blend" name="poster" position="865,180" size="142,215" zPosition="1"/>
                <widget name="posterbackground" position="432,174" size="418,225" zPosition="1" transparent="1" alphatest="on"/>
                <widget font="Regular;22" name="genre" foregroundColor="#005395c3" backgroundColor="#907F6B" position="380,500" size="860,24" zPosition="1" transparent="1"/>
		<widget font="Regular;22" name="castlabel" foregroundColor="#00999999" backgroundColor="#907F6B" position="381,528" size="860,175" zPosition="1" transparent="1" />
		<widget font="Regular;18" name="actors"  foregroundColor="#00999999" backgroundColor="#907F6B" position="276,180" size="142,215" zPosition="1" transparent="1" />
                <widget font="Regular;22" name="year"  foregroundColor="#00999999" backgroundColor="#907F6B" position="41,575" size="320,24" zPosition="1" transparent="1"/>
	        <widget font="Regular;20" name="director"  foregroundColor="#00999999" backgroundColor="#907F6B" position="41,604" size="320,24" zPosition="1" transparent="1"/>
	        <widget font="Regular;20" name="Country"  foregroundColor="#00999999" backgroundColor="#907F6B" position="41,632" size="320,24" zPosition="1" transparent="1"/>
                <widget source="Service" render="Label"  foregroundColor="#00999999" backgroundColor="#907F6B" position="41,660" zPosition="1" size="210,24" font="Regular;22" transparent="1">
                <convert type="MovieInfo">FileSize</convert>
                </widget>
		</screen>"""  

    skin_hd2 = """
                <screen name="EventViewMovieSelection" position="0,0" size="1280,720" title="EventViewMovieSelection" flags="wfNoBorder">
                <widget name="Country" position="829,485" size="412,20" font="Regular; 20" zPosition="5" halign="right" foregroundColor="#008f8f8f" backgroundColor="#25101010" transparent="1" valign="center"/>
                <widget name="year" position="829,509" size="412,20" font="Regular; 20" zPosition="5" halign="right" foregroundColor="#008f8f8f" backgroundColor="#25101010" transparent="1" valign="center"/>
                <widget source="Service" render="Label" position="253,609" zPosition="5" size="220,30" font="Regular; 25" halign="center" backgroundColor="#41444444" transparent="1" foregroundColor="#00000000">
                <convert type="MovieInfo">FileSize</convert>
                </widget>
                <widget name="director" position="838,452" size="412,22" font="Regular; 20" zPosition="5" halign="left" foregroundColor="#00c0c0c0" backgroundColor="#25101010" transparent="1" valign="center"/>
                <widget name="posterbackground" position="0,0" zPosition="-5" size="1280,720" transparent="1" alphatest="on"/>
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/bg_ms.png" position="center,center" zPosition="-3" size="1280,720" alphatest="blend" />
                <widget name="actors" font="Regular; 17" foregroundColor="#00c0c0c0" backgroundColor="#25101010" position="741,346" size="508,75" zPosition="5" transparent="1" />
                <widget name="genre" font="Regular; 20" foregroundColor="#00c0c0c0" position="838,427" size="412,22" zPosition="5" transparent="1" backgroundColor="#25101010" halign="left"/>
                <widget name="castlabel" position="742,87" size="513,250" font="Regular; 18" zPosition="5" halign="left" foregroundColor="#00ffffff" backgroundColor="#25101010" transparent="1" valign="top"/>
                <widget source="global.CurrentTime" render="Label" position="866,61" size="380,22" font="Regular; 20" halign="right" backgroundColor="#00000000" transparent="1" foregroundColor="#00bab329" zPosition="5">
                <convert type="ClockToText">Date</convert>
                </widget>
                <widget source="global.CurrentTime" render="Label" position="1046,21" size="200,40" zPosition="5" font="Regular; 40" valign="center" halign="right" backgroundColor="#14101010" transparent="1" foregroundColor="#00bab329">
                <convert type="ClockToText">Default</convert>
                </widget>
                <widget font="Regular;40" name="title" position="253,545" size="850,45" transparent="1" valign="center" halign="left" zPosition="5" foregroundColor="#00000000" backgroundColor="#00dddddd" />
                <widget alphatest="blend" name="starsbg" position="1032,609" size="210,21" zPosition="5" />
                <widget font="Regular;22" halign="right" name="ratinglabel" foregroundColor="#00bab329" position="863,635" size="380,25" transparent="1" zPosition="5" />
                <widget font="Regular;22" name="voteslabel" halign="right" position="863,665" size="380,25" foregroundColor="#00bab329" transparent="1" zPosition="5" />
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ramka185.png" position="67,380" zPosition="6" size="185, 278" transparent="1" alphatest="blend" />
                <widget name="poster" position="77,392" zPosition="5" size="165,253" transparent="1" alphatest="on"/>
		</screen>"""
    skin_hd3 = """
                <screen name="EventViewMovieSelection" position="0,0" size="1280,720" title="Movie View" flags="wfNoBorder">
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/transparent.png" position="0,0" zPosition="-1" size="1280,720" alphatest="blend" /> 
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/icons/h.264.png" position="40,47" zPosition="-2" size="70,46" alphatest="blend" />
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/icons/dts-hd.png" position="125,47" zPosition="-2" size="70,46" alphatest="blend" />
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/icons/blu-ray.png" position="1085,47" zPosition="-2" size="70,46" alphatest="blend" />           
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/icons/1080i.png" position="1170,47" zPosition="-2" size="70,46" alphatest="blend" />      
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/icons/flag_us.png" position="290,610" zPosition="-2" size="70,53" alphatest="blend" />
                <widget name="title" position="250,37" size="780,39" font="Go;38" halign="center" zPosition="3" foregroundColor="#000099ff" backgroundColor="#14101010" transparent="1" valign="center" />
                <widget name="starsbg" position="50,200" size="210,21" zPosition="3" alphatest="blend" />
                <widget name="ratinglabel" position="50,525" zPosition="1" size="270,23" halign="center" font="Go;20" foregroundColor="#00f0b400" backgroundColor="#14101010" transparent="1" />
                <widget name="voteslabel" halign="center" zPosition="1" position="50,555" size="270,23" font="Go;20" foregroundColor="#00f0b400" backgroundColor="#14101010" transparent="1" />
                <widget name="posterbackground" position="0,0" zPosition="-2" size="1280,720" transparent="1" alphatest="on" />
                <widget name="poster" position="65,250" zPosition="-2" size="178,267" transparent="1" alphatest="on" />
                <widget name="actors" position="388,442" size="860,21" zPosition="3" font="Go;18" foregroundColor="#63ea7c" backgroundColor="#14101010" halign="left" transparent="1" />
                <widget name="director" position="395,661" size="550,21" font="Go; 18" zPosition="3" halign="left" foregroundColor="#000099ff" backgroundColor="#14101010" transparent="1" />
                <widget name="genre" position="250,82" size="780,20" font="Go;18" halign="center" foregroundColor="#008f8f8f" zPosition="3" backgroundColor="#14101010" transparent="1" />
                <widget name="year" font="Go;20" position="42,592" halign="left" size="210,22" foregroundColor="#008f8f8f" backgroundColor="#14101010" transparent="1" zPosition="3" />
                <widget name="Country" font="Go;20" position="42,630" halign="left" size="210,22" foregroundColor="#008f8f8f" backgroundColor="#14101010" transparent="1" noWrap="1" zPosition="3" />      
                <widget source="Service" render="Label" position="391,475" zPosition="1" size="860,163" font="Go;20" shadowColor="black" shadowOffset="-2,-2" halign="left" foregroundColor="#00cccc17" backgroundColor="#14101010" transparent="1">
                <convert type="MovieInfo">Description</convert>
                </widget>       
                </screen>"""
                
    skin_hd4 = """
                <screen name="EventViewMovieSelection" position="0,0" size="1280,720" title="Movie View" flags="wfNoBorder">
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/concert.png" position="0,0" zPosition="-1" size="1280,720" alphatest="blend" /> 
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/icons/h.2641.png" position="50,85" zPosition="1" size="68,51" alphatest="blend" />
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/icons/dts.png" position="50,140" zPosition="1" size="68,51" alphatest="blend" />
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/icons/blu-ray1.png" position="50,195" zPosition="1" size="68,51" alphatest="blend" />           
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/icons/ac3.png" position="50,250" zPosition="1" size="68,51" alphatest="blend" />      
                <eLabel text="Режиссер:" position="320,522" size="120,22" font="Scout1;23" zPosition="3" halign="left" transparent="1" foregroundColor="#00cccc17" backgroundColor="#14101010" />
                <eLabel text="Актеры:" position="60,675" size="120,22" font="Scout1;23" zPosition="3" halign="left" transparent="1" foregroundColor="#00cccc17" backgroundColor="#14101010" />
                <widget name="title" position="250,20" size="780,48" font="Scout;46" halign="center" zPosition="3" foregroundColor="#000099ff" backgroundColor="#14101010" transparent="1" valign="center" />
                <widget name="starsbg" position="90,25" size="210,21" zPosition="3" alphatest="blend" />
                <widget name="ratinglabel" position="80,50" zPosition="1" size="270,23" halign="center" font="Scout1;23" foregroundColor="#00f0b400" backgroundColor="#14101010" transparent="1" />
                <widget name="voteslabel" halign="right" zPosition="1" position="950,522" size="270,23" font="Scout1;23" foregroundColor="#008f8f8f" backgroundColor="#14101010" transparent="1" />
                <widget name="posterbackground" position="446,84" zPosition="-2" size="822,462" transparent="1" alphatest="on" />
                <widget name="poster" position="140,80" zPosition="-2" size="290,394" transparent="1" alphatest="on" />
                <widget name="actors" position="155,675" size="1000,22" zPosition="3" font="Scout1;23" foregroundColor="#000099ff" backgroundColor="#14101010" halign="left" transparent="1" />
                <widget name="director" position="428,522" size="550,21" font="Scout1; 23" zPosition="3" halign="left" foregroundColor="#000099ff" backgroundColor="#14101010" transparent="1" />
                <widget name="genre" position="900,52" size="300,22" font="Scout;22" halign="right" foregroundColor="#008f8f8f" zPosition="3" backgroundColor="#14101010" transparent="1" />
                <widget name="year" font="Scout1;22" position="95,522" halign="left" size="210,22" foregroundColor="#008f8f8f" backgroundColor="#14101010" transparent="1" zPosition="3" />
                <widget name="Country" font="Scout1;22" position="222,522" halign="left" size="210,22" foregroundColor="#008f8f8f" backgroundColor="#14101010" transparent="1" noWrap="1" zPosition="3" />      
                <widget source="Service" render="Label" position="60,555" zPosition="1" size="1160,107" font="Regular;18" shadowColor="black" shadowOffset="-2,-2" halign="left" foregroundColor="white" backgroundColor="#14101010" transparent="1">
                <convert type="MovieInfo">Description</convert>
                </widget>       
                </screen>""" 
    def __chooseSkin(self):
            if config.movielist.EventViewMovieSelectionskins.value == "0":
	            return EventViewMovieSelection.skin_hd
	    if config.movielist.EventViewMovieSelectionskins.value == "1":
                    return EventViewMovieSelection.skin_hd1
	    if config.movielist.EventViewMovieSelectionskins.value == "2":
                    return EventViewMovieSelection.skin_hd2
	    if config.movielist.EventViewMovieSelectionskins.value == "3":
                    return EventViewMovieSelection.skin_hd3
	    if config.movielist.EventViewMovieSelectionskins.value == "4":
                    return EventViewMovieSelection.skin_hd4                
    
    def __init__(self, session, movietitle, name2, pathname, current):
	Screen.__init__(self, session)
	self.skin=self.__chooseSkin()	
	self.onShow.append(self.getposters)
	self.picon = ePicLoad()
	self['Service'] = ServiceEvent()	
	self["poster"] = Pixmap()
	self["posterbackground"] = Pixmap()
	self["starsbg"] = Pixmap()
	self["title"] = Label("")
	self["dirs"] = Label("")
	self["castlabel"] = ScrollLabel("")
	self["extralabel"] = Label("")
	self["ratinglabel"] = Label("")
	self["voteslabel"] = Label("")
        self["actors"] = Label("")
        self["year"] = Label("")
        self["director"] = Label("")
        self["genre"] = Label("")
        self["Country"] = Label("")
	self.eit = movietitle + "eit"
	self.txt = movietitle + "txt"
	self.name2 = name2
	self.current = current
	self.movietitle = pathname
        self['actions'] = ActionMap(['OkCancelActions', 'DirectionActions'], {'ok': self.exit,
        'cancel': self.exit,
        'down': self.pageDown,
        'up': self.pageUp,
        'left': self.pageUp,
        'right': self.pageDown}, -1)
        
    def pageUp(self):
        self["castlabel"].pageUp()
	
    def pageDown(self):
        self["castlabel"].pageDown()
	
    def exit(self):
        self.close()

    def getPanelmenu(self):
        Extratext2 = ''
        name = ''
        Country = ''
        Country2 = ''
        genre = ''
        descript = ''
        ratingall = ''
        director = ''
        actors = ''
        year = ''
        Ratingtext = ''
        Votestext = ''
        description = ''
        fail = ''
        nams = ''
        nametxt = ''
        fileName = ''
        self['Service'].newService(self.current)
        if config.movielist.hide_extensions.value:
            fileName, fileExtension = os.path.splitext(self.name2)
        else:
            fileName = self.name2       
        if fileExists(self.txt):
            readmetafile = open(self.txt, "r")
	    try:
		Country2 = readmetafile.readline()[0:-1]
		if "Страна:" in Country2:
                    if config.plugins.tmbd.movieInfo.value:
                        Country = Country2.replace('Страна: ', '')
                    else:
                        Country = Country2
                else:
                        Country = '' 
	    except:
		    Country = ''                                
	    try:
		genre = readmetafile.readline()[0:-1]
		if config.plugins.tmbd.movieInfo.value:
                    genre = genre.replace('Жанр: ', '')
	    except:
                genre = '' 
	    try:
		description = readmetafile.readline()[0:-1]
	    except:
		description = ''                                
	    try:
		ratingall = readmetafile.readline()[0:-1]
	    except:
                ratingall = '' 
	    try:
		actors = readmetafile.readline()[0:-1]
		if config.plugins.tmbd.movieInfo.value:
                    actors = actors.replace('В ролях: ', '')	
	    except:
                actors = ''
	    try:
		director = readmetafile.readline()[0:-1]
		if config.plugins.tmbd.movieInfo.value:
                    director = director.replace('Режиссер: ', '')
	    except:
                director = ''
	    try:
		year = readmetafile.readline()[0:-1]
		if config.plugins.tmbd.movieInfo.value:
                    year = year.replace('Год выпуска: ', '')
	    except:
                year = ''
            nams = readmetafile.readline()[0:-1]
	    if "Origname:" in nams:
                nams = nams.split('Origname:')[1].strip()
            else:
                nams = ""                  
            readmetafile.close()
        elif not fileExists(self.txt) and fileExists(self.eit):
            from Plugins.Extensions.TMBD import event
            evt = event.Event()
            evt.readFromFile(self.eit)
            fail = '%s' % (evt.getShortDescription() + evt.getExtendedDescription())                                
            if fail != "":
                    import StringIO    
                    readmetafile = StringIO.StringIO(fail)
		    try:
			Country2 = readmetafile.readline()[0:-1]
			if "Страна:" in Country2:
                            if config.plugins.tmbd.movieInfo.value:
                                Country = Country2.replace('Страна: ', '')
                            else:
                                Country = Country2
                        else:
                                Country = '' 
		    except:
			    Country = ''                                
		    try:
			    genre = readmetafile.readline()[0:-1]
			    if config.plugins.tmbd.movieInfo.value:
                                genre = genre.replace('Жанр: ', '')
		    except:
                            genre = '' 
		    try:
				descript = readmetafile.readline()[0:-1]
                                if descript != "":
                                        description = descript
                                elif descript == "" and fail != "":
                                        description = fail 				
		    except:
				descript = ''                                
		    try:
			    ratingall = readmetafile.readline()[0:-1]
		    except:
                            ratingall = '' 
		    try:
			    actors = readmetafile.readline()[0:-1]
			    if config.plugins.tmbd.movieInfo.value:
                                actors = actors.replace('В ролях: ', '')	
		    except:
                            actors = ''
		    try:
			    director = readmetafile.readline()[0:-1]
			    if config.plugins.tmbd.movieInfo.value:
                                director = director.replace('Режиссер: ', '')
		    except:
                            director = ''
		    try:
			    year = readmetafile.readline()[0:-1]
			    if config.plugins.tmbd.movieInfo.value:
                                year = year.replace('Год выпуска: ', '')
		    except:
                            year = ''
                    nams = readmetafile.readline()[0:-1]
	            if "Origname:" in nams:
                        nams = nams.split('Origname:')[1].strip()
                    else:
                        nams = ""                               
                    readmetafile.close()
        if config.movielist.originalname.value:
            if nams != "":
                    nametxt = nams
            else:
                    nametxt = fileName 
        else:
            nametxt = fileName
        self["title"].setText("%s" % (nametxt))            
        self["castlabel"].setText("%s" % (description))
        Extratext2 = "%s\n%s\n%s\n%s\n%s" % (Country, year, director, genre, actors)
        self["extralabel"].setText("%s" % (Extratext2))
        self["actors"].setText("%s" % (actors))
        self["year"].setText("%s" % (year))
        self["director"].setText("%s" % (director))
        self["genre"].setText("%s" % (genre))
        self["Country"].setText("%s" % (Country))        
        if 'Рейтинг:' in ratingall:
                        name = ratingall.split('Рейтинг:')[1].split('.')[0].strip()
                        starss = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/starsbar/%s.png") % (name)
                        self["starsbg"].instance.setPixmapFromFile(starss)
                        Ratingtext = ratingall.split('Рейтинг:')[1].split(')')[0].strip()
                        Votestext = ratingall.split('Рейтинг:')[0].strip()
                        self["voteslabel"].setText(Votestext.replace("/", ""))
                        self["ratinglabel"].setText("Рейтинг: %s)" % (Ratingtext))
        else:
                        starss = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/starsbar/0.png")
                        self["starsbg"].instance.setPixmapFromFile(starss)
                        self["ratinglabel"].setText("Нет данных")
                        self["voteslabel"].setText("Нет данных")
        self["dirs"].setText(self.movietitle)

    def getposters(self):
        counttochra = 1
        altname = ""
        namepng = ""
 	counttochra = int(self.name2.count("."))
	if "_" in self.name2:
                self.name2 = self.name2.replace("_", " ")
	if counttochra > 1:
            counttochra = counttochra - 1
            self.name2 = self.name2.replace(".", " ", counttochra)        
        path = '/media/hdd/covers/'
        if fileExists(path + self.name2 + '.jpg'):
            namepng = self.name2
        else:
            altname = os.path.split(self.movietitle)[0]
            namepng = self.getalttext2(altname) 
	self.search_poster(namepng)        
	if self["posterbackground"].instance.size().width() != -1:
            self.search_posterbackground(namepng)
        self.getPanelmenu()    

    def search_posterbackground(self, name2):
            coversposter = ""
            covers = ""
	    covers = "/media/hdd/covers/%s_big.jpg" % (name2)
            if fileExists(covers):		    
                coversposter = covers               
            else:
                coversposter = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/backdrop.jpg")                
            png = loadPic(coversposter, self["posterbackground"].instance.size().width(), self["posterbackground"].instance.size().height(), 3, 0, 0, 1)    
            self["posterbackground"].instance.setPixmap(png)

    def getalttext2(self, filename):
        altext = ""
        name = ""
        if filename != "":
	        p = os.path.split(filename)
	        if not p[1]:
		        p = os.path.split(p)
                name = '%s' % (p[1])
 	        counttochra = int(name.count("."))
	        if "_" in name:
                    name = name.replace("_", " ")
	        if counttochra > 1:
                    cont = counttochra - 1
                    name = name.replace(".", " ", cont)                
	return name             
            
    def search_poster(self, name2):
            coversposter = ""
            covers = "/media/hdd/covers/%s.jpg" % (name2)
            if fileExists(covers):
                coversposter = covers
            else:
                coversposter = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/picon_default.png")
            if self["poster"].instance.size().width() != -1:
		    self["poster"].instance.setScale(1)
                    self.picon.setPara((self["poster"].instance.size().width(), self["poster"].instance.size().height(), 1, 1, False, 1, '#00000000'))
                    self.picon.startDecode(coversposter, 0, 0, False)               
                    png = self.picon.getData()				
	            self["poster"].instance.setPixmap(png)                
            else:
                pass

class MovieSelectionPreviem(Screen):
    skin_hd = """
                <screen name="MovieSelectionPreviem" position="0,0" size="1280,720" title="MovieSelectionPreviem" flags="wfNoBorder">
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/MovieSelectionPreviem.png" position="0,0" zPosition="-3" size="1280,720" />
                <widget font="Regular;22" name="dirs" position="71,41" foregroundColor="#00bab329" backgroundColor="#14101010" size="800,28" transparent="1" valign="center" />
                <widget font="Regular;22" name="title" position="463,130" foregroundColor="#00bab329" backgroundColor="#14101010" size="740,28" transparent="1" valign="center" />
                <widget alphatest="blend" name="starsbg"  position="119,132" size="210,21" zPosition="2" />
                <widget font="Regular;20" halign="center" name="ratinglabel" foregroundColor="#00f0b400" backgroundColor="#14101010" position="120,570" size="210,23" transparent="1" />
                <widget font="Regular;20" name="voteslabel" halign="center" position="92,599" size="270,23" foregroundColor="#00f0b400" backgroundColor="#14101010" transparent="1" />
                <widget alphatest="blend" name="poster" position="82,164" size="285,398" />
                <widget font="Regular;20" name="castlabel" foregroundColor="#00bab329" backgroundColor="#14101010" position="463,417" size="740,210" transparent="1" />
                <widget font="Regular;20" name="extralabel" position="463,166" size="740,245" transparent="1" />
                <widget source="global.CurrentTime" render="Label" position="1007,24" size="140,27" zPosition="2" font="Regular;26" valign="top" halign="center" foregroundColor="#00bab329" backgroundColor="#14101010" transparent="1">
                <convert type="ClockToText">Default</convert>
                </widget>
                <widget source="global.CurrentTime" render="Label" position="935,54" size="280,24" font="Regular;22" halign="center" foregroundColor="#00999999" backgroundColor="#14101010" transparent="1">
                <convert type="ClockToText">Format:%A, %d.%m.%Y</convert>
                </widget>
		</screen>"""

    skin_hd1 = """
                <screen name="MovieSelectionPreviem" position="0,0" size="1280,720" title="MovieSelectionPreviem" flags="wfNoBorder">
                <widget font="Regular;40" name="title" halign="center" position="267,490" foregroundColor="#00000000" backgroundColor="#AEAEAE" size="740,42" zPosition="2" transparent="1" valign="center" />
                <widget alphatest="blend" name="starsbg" position="1037,448" size="210,21" zPosition="2" />
                <widget font="Regular;20" halign="left" name="ratinglabel" foregroundColor="#00f0b400" backgroundColor="#2C2C2C" position="1037,474" size="210,23" transparent="1" zPosition="2" />
                <widget font="Regular;20" name="voteslabel" halign="left" position="1037,501" size="210,23" foregroundColor="#00f0b400" backgroundColor="#2C2C2C" transparent="1" zPosition="2" />
                <widget alphatest="blend" name="poster" position="47,440" size="165,253" zPosition="5" />
                <widget font="Regular;20" name="castlabel" foregroundColor="#00dcdcdc" backgroundColor="#2C2C2C" position="258,594" size="770,110" transparent="1" zPosition="2" />
                <widget font="Regular;20" name="actors" foregroundColor="#0058bcff" backgroundColor="#2C2C2C" position="258,546" halign="left" size="770,44" transparent="1" zPosition="2" />
                <widget name="posterbackground" position="0,0" zPosition="-5" size="1280,720" transparent="1" alphatest="on"/>
                <widget font="Regular;20" name="year" foregroundColor="#0058bcff" backgroundColor="#2C2C2C" position="1037,530" halign="left" size="210,22" transparent="1" zPosition="2" />
                <widget font="Regular;20" name="Country" foregroundColor="#0058bcff" backgroundColor="#2C2C2C" position="1037,558" halign="left" size="210,22" transparent="1" noWrap="1" zPosition="2" />
                <widget font="Regular;20" name="director" foregroundColor="#0058bcff" backgroundColor="#2C2C2C" position="1037,587" halign="left" size="210,22" transparent="1" noWrap="1" zPosition="2" />
                <widget font="Regular;20" name="genre" foregroundColor="#0058bcff" backgroundColor="#2C2C2C" position="1037,616" halign="left" size="210,44" transparent="1" zPosition="2" />
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ramka185.png" position="37,423" zPosition="6" size="185, 278" transparent="1" alphatest="blend" />
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/fon-fs8.png" position="0,409" zPosition="-3" size="1280,311" alphatest="blend" />
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ext.png" position="1036,661" zPosition="2" size="71, 40" transparent="1" alphatest="blend" />
                <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/saze.png" position="1110,661" zPosition="2" size="127, 40" transparent="1" alphatest="blend" />
                <widget font="Regular;24" name="extension" foregroundColor="#2256c856" backgroundColor="#2C2C2C" position="1037,663" halign="center" size="70,24" transparent="1" zPosition="3" />
                <widget source="Service" render="Label" position="1112,666" zPosition="3" size="124,22" font="Regular;20" halign="center" backgroundColor="#2C2C2C" transparent="1" foregroundColor="#2256c856">
                <convert type="MovieInfo">FileSize</convert>
                </widget>
		</screen>"""
    
    def __chooseSkin(self):
            if config.movielist.MovieSelectionPreviemskins.value == "0":
	            return MovieSelectionPreviem.skin_hd
	    if config.movielist.MovieSelectionPreviemskins.value == "1":
                    return MovieSelectionPreviem.skin_hd1
                
    def __init__(self, session, current, path):
	Screen.__init__(self, session)
	self.skin=self.__chooseSkin()	
	self.onShow.append(self.getPanelmenu)
        self.picon = ePicLoad()	
	self['Service'] = ServiceEvent()
	self["poster"] = Pixmap()
	self["posterbackground"] = Pixmap()
	self["starsbg"] = Pixmap()
	self["title"] = Label("")
	self["dirs"] = Label("")
	self["castlabel"] = ScrollLabel("")
	self["extralabel"] = Label("")
	self["ratinglabel"] = Label("")
	self["voteslabel"] = Label("")
        self["actors"] = Label("")
        self["year"] = Label("")
        self["director"] = Label("")
        self["genre"] = Label("")
        self["Country"] = Label("")
        self["extension"] = Label("")
	self.current = current
	self.path = path
        self['actions'] = ActionMap(['OkCancelActions', 'DirectionActions'], {'ok': self.okclik,
        'cancel': self.exit,
        'down': self.pageDown,
        'up': self.pageUp,
        'left': self.pageUp,
        'right': self.pageDown}, -1)
        self.extenshion()


    def pageUp(self):
        self["castlabel"].pageUp()
	
    def pageDown(self):
        self["castlabel"].pageDown()
	
    def exit(self):
        self.close(False)

    def okclik(self):
        self.close(True)

    def extenshion(self):
	extension = self.path
	extension = extension.split('.')
	extension = extension[-1].lower()
	self["extension"].setText(extension)        

    def getPanelmenu(self):
        Extratext2 = ''
        name = ''
        Country = ''
        Country2 = ''
        genre = ''
        descript = ''
        ratingall = ''
        director = ''
        actors = ''
        year = ''
        Ratingtext = ''
        Votestext = ''
        description = ''
        fail = ''
        movietitle = ""
        name2 = ""
        number = ""
        pathname = ""
        filename = ""
        nameext = ""
        altext = ""
        namefil = ""
        namepng = ""
        movietitletxt = ""
        movietitleeit = ""
        movietitletxt2 = ""
        movietitleeit2 = ""        
        altname = ""
        nameext2 = ""
        nams = ''
        nametxt = ''
        fileName = ''        
        counttochra = 1
        serviceHandler = eServiceCenter.getInstance()
        info = serviceHandler.info(self.current)
        name = info and info.getName(self.current) or _('this recording')
	if ".iso" in self.path:
            name2 = os.path.split(self.path)[1]
        else:    
            name2 = name
        if config.plugins.tmbd.movieselectionparts.value == "none":
            nameext = self.path[:-2]
            movietitletxt = nameext + "txt"
            movietitleeit = nameext + "eit"
            if fileExists(movietitletxt) or fileExists(movietitleeit):
                txt = movietitletxt
                eit = movietitleeit
            else:
                if self.path != "":
                    altext = os.path.split(self.path)[0]
                    txt = altext + ".txt"
                    eit = altext + ".eit"
        else:
            altext, filename = os.path.split(self.path)
            nameext = config.plugins.tmbd.movieselectionparts.value + "/" + filename[:-2]
            nameext2 = self.path[:-2]
            movietitletxt = nameext + "txt"
            movietitleeit = nameext + "eit"
            movietitletxt2 = nameext2 + "txt"
            movietitleeit2 = nameext2 + "eit"             
            if fileExists(movietitletxt) or fileExists(movietitleeit):
                txt = movietitletxt
                eit = movietitleeit
            elif fileExists(movietitletxt2) or fileExists(movietitleeit2) and  not fileExists(movietitletxt) or not fileExists(movietitleeit):                
                txt = movietitletxt2
                eit = movietitleeit2
            else:
                namefil = self.getalttext(altext)
                movietitle = config.plugins.tmbd.movieselectionparts.value + "/" + namefil
                txt = movietitle + ".txt"
                eit = movietitle + ".eit"
        pathname = self.path
        if config.movielist.hide_extensions.value:
            fileName, fileExtension = os.path.splitext(name2)
        else:
            fileName = name2
        if fileExists(txt):
            readmetafile = open(txt, "r")
	    try:
		Country2 = readmetafile.readline()[0:-1]
		if "Страна:" in Country2:
                    if config.plugins.tmbd.movieInfo.value:
                        Country = Country2.replace('Страна: ', '')
                    else:
                        Country = Country2
                else:
                        Country = '' 
	    except:
		    Country = ''                                
	    try:
		genre = readmetafile.readline()[0:-1]
		if config.plugins.tmbd.movieInfo.value:
                    genre = genre.replace('Жанр: ', '')
	    except:
                genre = '' 
	    try:
		description = readmetafile.readline()[0:-1]
	    except:
		description = ''                                
	    try:
		ratingall = readmetafile.readline()[0:-1]
	    except:
                ratingall = '' 
	    try:
		actors = readmetafile.readline()[0:-1]
		if config.plugins.tmbd.movieInfo.value:
                    actors = actors.replace('В ролях: ', '')	
	    except:
                actors = ''
	    try:
		director = readmetafile.readline()[0:-1]
		if config.plugins.tmbd.movieInfo.value:
                    director = director.replace('Режиссер: ', '')
	    except:
                director = ''
	    try:
		year = readmetafile.readline()[0:-1]
		if config.plugins.tmbd.movieInfo.value:
                    year = year.replace('Год выпуска: ', '')
	    except:
                year = ''
            nams = readmetafile.readline()[0:-1]
	    if "Origname:" in nams:
                nams = nams.split('Origname:')[1].strip()
            else:
                nams = ""                
            readmetafile.close()
        elif not fileExists(txt) and fileExists(eit):
            from Plugins.Extensions.TMBD import event
            evt = event.Event()
            evt.readFromFile(eit)
            fail = '%s' % (evt.getShortDescription() + evt.getExtendedDescription())                                
            if fail != "":
                    import StringIO    
                    readmetafile = StringIO.StringIO(fail)
		    try:
			Country2 = readmetafile.readline()[0:-1]
			if "Страна:" in Country2:
                            if config.plugins.tmbd.movieInfo.value:
                                Country = Country2.replace('Страна: ', '')
                            else:
                                Country = Country2
                        else:
                                Country = '' 
		    except:
			    Country = ''                                
		    try:
			    genre = readmetafile.readline()[0:-1]
			    if config.plugins.tmbd.movieInfo.value:
                                genre = genre.replace('Жанр: ', '')
		    except:
                            genre = '' 
		    try:
				descript = readmetafile.readline()[0:-1]
                                if descript != "":
                                        description = descript
                                elif descript == "" and fail != "":
                                        description = fail 				
		    except:
				descript = ''                                
		    try:
			    ratingall = readmetafile.readline()[0:-1]
		    except:
                            ratingall = '' 
		    try:
			    actors = readmetafile.readline()[0:-1]
			    if config.plugins.tmbd.movieInfo.value:
                                actors = actors.replace('В ролях: ', '')	
		    except:
                            actors = ''
		    try:
			    director = readmetafile.readline()[0:-1]
			    if config.plugins.tmbd.movieInfo.value:
                                director = director.replace('Режиссер: ', '')
		    except:
                            director = ''
		    try:
			    year = readmetafile.readline()[0:-1]
			    if config.plugins.tmbd.movieInfo.value:
                                year = year.replace('Год выпуска: ', '')
		    except:
                            year = ''
                    nams = readmetafile.readline()[0:-1]
	            if "Origname:" in nams:
                         nams = nams.split('Origname:')[1].strip()
                    else:
                        nams = ""                            
                    readmetafile.close()
        if config.movielist.originalname.value:
            if nams != "":
                    nametxt = nams
            else:
                    nametxt = fileName 
        else:
            nametxt = fileName
        self["title"].setText("%s" % (nametxt))                      
        self['Service'].newService(self.current)             
        self["castlabel"].setText("%s" % (description))
        Extratext2 = "%s\n%s\n%s\n%s\n%s" % (Country, year, director, genre, actors)
        self["extralabel"].setText("%s" % (Extratext2))
        self["actors"].setText("%s" % (actors))
        self["year"].setText("%s" % (year))
        self["director"].setText("%s" % (director))
        self["genre"].setText("%s" % (genre))
        self["Country"].setText("%s" % (Country)) 
        if 'Рейтинг:' in ratingall:
                        name = ratingall.split('Рейтинг:')[1].split('.')[0].strip()
                        starss = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/starsbar/%s.png") % (name)
                        self["starsbg"].instance.setPixmapFromFile(starss)
                        Ratingtext = ratingall.split('Рейтинг:')[1].split(')')[0].strip()
                        Votestext = ratingall.split('Рейтинг:')[0].strip()
                        self["voteslabel"].setText(Votestext.replace("/", ""))
                        self["ratinglabel"].setText("Рейтинг: %s)" % (Ratingtext))
        else:
                        starss = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/starsbar/0.png")
                        self["starsbg"].instance.setPixmapFromFile(starss)
                        self["ratinglabel"].setText("Нет данных")
                        self["voteslabel"].setText("Нет данных")
        self["dirs"].setText(pathname)
 	counttochra = int(name2.count("."))
	if "_" in name2:
                name2 = name2.replace("_", " ")
	if counttochra > 1:
            counttochra = counttochra - 1
            name2 = name2.replace(".", " ", counttochra)        
        path = '/media/hdd/covers/'
        if fileExists(path + name2 + '.jpg'):
            namepng = name2
        else:
            altname = os.path.split(self.path)[0]
            namepng = self.getalttext2(altname) 
	self.search_poster(namepng)
	if self["posterbackground"].instance.size().width() != -1:
            self.search_posterbackground(namepng)

    def getalttext(self, filename):
        altext = ""
        name = ""
        if filename != "":
	        p = os.path.split(filename)
	        if not p[1]:
		        p = os.path.split(p)
                name = '%s' % (p[1])                  
	return name

    def getalttext2(self, filename):
        altext = ""
        name = ""
        if filename != "":
	        p = os.path.split(filename)
	        if not p[1]:
		        p = os.path.split(p)
                name = '%s' % (p[1])
 	        counttochra = int(name.count("."))
	        if "_" in name:
                    name = name.replace("_", " ")
	        if counttochra > 1:
                    cont = counttochra - 1
                    name = name.replace(".", " ", cont)                
	return name    

    def search_posterbackground(self, name2):
            coversposter = ""
            covers = ""
	    covers = "/media/hdd/covers/%s_big.jpg" % (name2)
            if fileExists(covers):		    
                coversposter = covers               
            else:
                coversposter = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/backdrop.jpg")                
            png = loadPic(coversposter, self["posterbackground"].instance.size().width(), self["posterbackground"].instance.size().height(), 3, 0, 0, 1)    
            self["posterbackground"].instance.setPixmap(png)

    def search_poster(self, name2):
            coversposter = ""
            covers = ""
	    covers = "/media/hdd/covers/%s.jpg" % (name2)
            if fileExists(covers):		    
                coversposter = covers               
            else:
                coversposter = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/picon_default.png")                
            if self["poster"].instance.size().width() != -1:
		    self["poster"].instance.setScale(1)
                    self.picon.setPara((self["poster"].instance.size().width(), self["poster"].instance.size().height(), 1, 1, False, 1, '#00000000'))
                    self.picon.startDecode(coversposter, 0, 0, False)               
                    png = self.picon.getData()				
	            self["poster"].instance.setPixmap(png) 
            else:
                pass               

